/* icon-factory.c generated by valac 0.36.12, the Vala compiler
 * generated from icon-factory.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Singleton class to hold icons.*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gobject/gvaluecollector.h>


#define TYPE_ICON_FACTORY (icon_factory_get_type ())
#define ICON_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_FACTORY, IconFactory))
#define ICON_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_FACTORY, IconFactoryClass))
#define IS_ICON_FACTORY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_FACTORY))
#define IS_ICON_FACTORY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_FACTORY))
#define ICON_FACTORY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_FACTORY, IconFactoryClass))

typedef struct _IconFactory IconFactory;
typedef struct _IconFactoryClass IconFactoryClass;
typedef struct _IconFactoryPrivate IconFactoryPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _gtk_icon_info_free0(var) ((var == NULL) ? NULL : (var = (gtk_icon_info_free (var), NULL)))
#define _icon_factory_unref0(var) ((var == NULL) ? NULL : (var = (icon_factory_unref (var), NULL)))
typedef struct _ParamSpecIconFactory ParamSpecIconFactory;

struct _IconFactory {
	GTypeInstance parent_instance;
	volatile int ref_count;
	IconFactoryPrivate * priv;
};

struct _IconFactoryClass {
	GTypeClass parent_class;
	void (*finalize) (IconFactory *self);
};

struct _IconFactoryPrivate {
	GtkIconTheme* _icon_theme;
	GFile* icons_dir;
};

struct _ParamSpecIconFactory {
	GParamSpec parent_instance;
};


static gpointer icon_factory_parent_class = NULL;
static IconFactory* icon_factory__instance;
static IconFactory* icon_factory__instance = NULL;

gpointer icon_factory_ref (gpointer instance);
void icon_factory_unref (gpointer instance);
GParamSpec* param_spec_icon_factory (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_icon_factory (GValue* value, gpointer v_object);
void value_take_icon_factory (GValue* value, gpointer v_object);
gpointer value_get_icon_factory (const GValue* value);
GType icon_factory_get_type (void) G_GNUC_CONST;
#define ICON_FACTORY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ICON_FACTORY, IconFactoryPrivate))
enum  {
	ICON_FACTORY_0_PROPERTY
};
#define ICON_FACTORY_ICON_TOOLBAR GTK_ICON_SIZE_LARGE_TOOLBAR
#define ICON_FACTORY_ICON_SIDEBAR GTK_ICON_SIZE_MENU
#define ICON_FACTORY_UNREAD_ICON_SIZE 16
#define ICON_FACTORY_STAR_ICON_SIZE 16
static IconFactory* icon_factory_new (void);
static IconFactory* icon_factory_construct (GType object_type);
GType geary_application_get_type (void) G_GNUC_CONST;
GearyApplication* geary_application_get_instance (void) G_GNUC_DEPRECATED;
GFile* geary_application_get_resource_directory (GearyApplication* self);
static void icon_factory_set_icon_theme (IconFactory* self, GtkIconTheme* value);
static GtkIconTheme* icon_factory_get_icon_theme (IconFactory* self);
void icon_factory_init (IconFactory* self);
static gint icon_factory_icon_size_to_pixels (IconFactory* self, GtkIconSize icon_size);
GIcon* icon_factory_get_theme_icon (IconFactory* self, const gchar* name);
GIcon* icon_factory_get_custom_icon (IconFactory* self, const gchar* name, GtkIconSize size);
static GdkPixbuf* icon_factory_get_missing_icon (IconFactory* self, gint size, GtkIconLookupFlags flags);
GtkIconInfo* icon_factory_lookup_icon (IconFactory* self, const gchar* icon_name, gint size, GtkIconLookupFlags flags);
static GdkPixbuf* icon_factory_aspect_scale_down_pixbuf (IconFactory* self, GdkPixbuf* pixbuf, gint size);
GdkPixbuf* icon_factory_load_symbolic (IconFactory* self, const gchar* icon_name, gint size, GtkStyleContext* style, GtkIconLookupFlags flags);
GdkPixbuf* icon_factory_load_symbolic_colored (IconFactory* self, const gchar* icon_name, gint size, GdkRGBA* color, GtkIconLookupFlags flags);
IconFactory* icon_factory_get_instance (void);
static void icon_factory_set_instance (IconFactory* value);
static void icon_factory_finalize (IconFactory * obj);


static IconFactory* icon_factory_construct (GType object_type) {
	IconFactory* self = NULL;
	GearyApplication* _tmp0_;
	GearyApplication* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GtkIconTheme* _tmp5_;
	GtkIconTheme* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	self = (IconFactory*) g_type_create_instance (object_type);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = geary_application_get_instance ();
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp1_ = _tmp0_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp2_ = geary_application_get_resource_directory (_tmp1_);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp3_ = _tmp2_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp4_ = g_file_get_child (_tmp3_, "icons");
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->icons_dir);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	self->priv->icons_dir = _tmp4_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_object_unref0 (_tmp3_);
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp5_ = gtk_icon_theme_get_default ();
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	icon_factory_set_icon_theme (self, _tmp5_);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp6_ = self->priv->_icon_theme;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp7_ = self->priv->icons_dir;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp8_ = g_file_get_path (_tmp7_);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp9_ = _tmp8_;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	gtk_icon_theme_append_search_path (_tmp6_, _tmp9_);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_free0 (_tmp9_);
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return self;
#line 161 "icon-factory.c"
}


static IconFactory* icon_factory_new (void) {
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return icon_factory_construct (TYPE_ICON_FACTORY);
#line 168 "icon-factory.c"
}


void icon_factory_init (IconFactory* self) {
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 175 "icon-factory.c"
}


static gint icon_factory_icon_size_to_pixels (IconFactory* self, GtkIconSize icon_size) {
	gint result = 0;
	GtkIconSize _tmp0_;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), 0);
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = icon_size;
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	switch (_tmp0_) {
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		case ICON_FACTORY_ICON_SIDEBAR:
#line 190 "icon-factory.c"
		{
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			result = 16;
#line 46 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			return result;
#line 196 "icon-factory.c"
		}
		default:
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		case ICON_FACTORY_ICON_TOOLBAR:
#line 201 "icon-factory.c"
		{
#line 50 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			result = 24;
#line 50 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			return result;
#line 207 "icon-factory.c"
		}
	}
}


GIcon* icon_factory_get_theme_icon (IconFactory* self, const gchar* name) {
	GIcon* result = NULL;
	const gchar* _tmp0_;
	GThemedIcon* _tmp1_;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = name;
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp1_ = (GThemedIcon*) g_themed_icon_new (_tmp0_);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_icon_get_type (), GIcon);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return result;
#line 229 "icon-factory.c"
}


GIcon* icon_factory_get_custom_icon (IconFactory* self, const gchar* name, GtkIconSize size) {
	GIcon* result = NULL;
	gint pixels = 0;
	GtkIconSize _tmp0_;
	gint _tmp1_;
	GFile* icon_file = NULL;
	GFile* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	gboolean _tmp15_;
	GFile* _tmp21_;
	GFileIcon* _tmp22_;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = size;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp1_ = icon_factory_icon_size_to_pixels (self, _tmp0_);
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	pixels = _tmp1_;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp2_ = self->priv->icons_dir;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp3_ = pixels;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp4_ = pixels;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp5_ = g_strdup_printf ("%dx%d", _tmp3_, _tmp4_);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp6_ = _tmp5_;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp7_ = g_file_get_child (_tmp2_, _tmp6_);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp8_ = _tmp7_;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp9_ = name;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp10_ = g_strdup_printf ("%s.svg", _tmp9_);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp11_ = _tmp10_;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp12_ = g_file_get_child (_tmp8_, _tmp11_);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp13_ = _tmp12_;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_free0 (_tmp11_);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_object_unref0 (_tmp8_);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_free0 (_tmp6_);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	icon_file = _tmp13_;
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp14_ = icon_file;
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp15_ = g_file_query_exists (_tmp14_, NULL);
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (!_tmp15_) {
#line 303 "icon-factory.c"
		GFile* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GFile* _tmp20_;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp16_ = self->priv->icons_dir;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp17_ = name;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp18_ = g_strdup_printf ("%s.svg", _tmp17_);
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp19_ = _tmp18_;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp20_ = g_file_get_child (_tmp16_, _tmp19_);
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_g_object_unref0 (icon_file);
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		icon_file = _tmp20_;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_g_free0 (_tmp19_);
#line 325 "icon-factory.c"
	}
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp21_ = icon_file;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp22_ = (GFileIcon*) g_file_icon_new (_tmp21_);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, g_icon_get_type (), GIcon);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_object_unref0 (icon_file);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return result;
#line 337 "icon-factory.c"
}


static GdkPixbuf* icon_factory_get_missing_icon (IconFactory* self, gint size, GtkIconLookupFlags flags) {
	GdkPixbuf* result = NULL;
	GError * _inner_error_ = NULL;
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 346 "icon-factory.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		GtkIconTheme* _tmp1_;
		gint _tmp2_;
		GtkIconLookupFlags _tmp3_;
		GdkPixbuf* _tmp4_;
		GdkPixbuf* _tmp5_;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp1_ = self->priv->_icon_theme;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp2_ = size;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp3_ = flags;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp4_ = gtk_icon_theme_load_icon (_tmp1_, "image-missing", _tmp2_, _tmp3_, &_inner_error_);
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp0_ = _tmp4_;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 366 "icon-factory.c"
			goto __catch65_g_error;
		}
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp5_ = _tmp0_;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp0_ = NULL;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		result = _tmp5_;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_g_object_unref0 (_tmp0_);
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		return result;
#line 379 "icon-factory.c"
	}
	goto __finally65;
	__catch65_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		err = _inner_error_;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_inner_error_ = NULL;
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp6_ = err;
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp7_ = _tmp6_->message;
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		g_warning ("icon-factory.vala:77: Couldn't load image-missing icon: %s", _tmp7_);
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_g_error_free0 (err);
#line 399 "icon-factory.c"
	}
	__finally65:
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		g_clear_error (&_inner_error_);
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		return NULL;
#line 410 "icon-factory.c"
	}
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	result = NULL;
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return result;
#line 416 "icon-factory.c"
}


GtkIconInfo* icon_factory_lookup_icon (IconFactory* self, const gchar* icon_name, gint size, GtkIconLookupFlags flags) {
	GtkIconInfo* result = NULL;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	GtkIconLookupFlags _tmp3_;
	GtkIconInfo* _tmp4_;
	GtkIconInfo* _tmp5_ = NULL;
	GtkIconInfo* _tmp6_;
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp1_ = icon_name;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp2_ = size;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp3_ = flags;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp4_ = gtk_icon_theme_lookup_icon (_tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	icon_info = _tmp4_;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp6_ = icon_info;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (_tmp6_ != NULL) {
#line 450 "icon-factory.c"
		GtkIconInfo* _tmp7_;
		GtkIconInfo* _tmp8_;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp7_ = icon_info;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp8_ = gtk_icon_info_copy (_tmp7_);
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_gtk_icon_info_free0 (_tmp5_);
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp5_ = _tmp8_;
#line 461 "icon-factory.c"
	} else {
		GtkIconTheme* _tmp9_;
		gint _tmp10_;
		GtkIconLookupFlags _tmp11_;
		GtkIconInfo* _tmp12_;
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp9_ = self->priv->_icon_theme;
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp10_ = size;
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp11_ = flags;
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp12_ = gtk_icon_theme_lookup_icon (_tmp9_, "text-x-generic-symbolic", _tmp10_, _tmp11_);
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_gtk_icon_info_free0 (_tmp5_);
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp5_ = _tmp12_;
#line 479 "icon-factory.c"
	}
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	result = _tmp5_;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_gtk_icon_info_free0 (icon_info);
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return result;
#line 487 "icon-factory.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return self ? g_object_ref (self) : NULL;
#line 494 "icon-factory.c"
}


static GdkPixbuf* icon_factory_aspect_scale_down_pixbuf (IconFactory* self, GdkPixbuf* pixbuf, gint size) {
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	GdkPixbuf* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint scaled_width = 0;
	gint scaled_height = 0;
	GdkPixbuf* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GdkPixbuf* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GdkPixbuf* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	GdkPixbuf* _tmp40_;
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp1_ = pixbuf;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp2_ = gdk_pixbuf_get_width (_tmp1_);
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp3_ = _tmp2_;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp4_ = size;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (_tmp3_ <= _tmp4_) {
#line 531 "icon-factory.c"
		GdkPixbuf* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp5_ = pixbuf;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp6_ = gdk_pixbuf_get_height (_tmp5_);
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp7_ = _tmp6_;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp8_ = size;
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp0_ = _tmp7_ <= _tmp8_;
#line 546 "icon-factory.c"
	} else {
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp0_ = FALSE;
#line 550 "icon-factory.c"
	}
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (_tmp0_) {
#line 554 "icon-factory.c"
		GdkPixbuf* _tmp9_;
		GdkPixbuf* _tmp10_;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp9_ = pixbuf;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		result = _tmp10_;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		return result;
#line 565 "icon-factory.c"
	}
#line 97 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp11_ = pixbuf;
#line 97 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp12_ = gdk_pixbuf_get_width (_tmp11_);
#line 97 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp13_ = _tmp12_;
#line 97 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp14_ = pixbuf;
#line 97 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp15_ = gdk_pixbuf_get_height (_tmp14_);
#line 97 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp16_ = _tmp15_;
#line 97 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (_tmp13_ >= _tmp16_) {
#line 581 "icon-factory.c"
		gdouble aspect = 0.0;
		gint _tmp17_;
		GdkPixbuf* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		gint _tmp21_;
		GdkPixbuf* _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp17_ = size;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp18_ = pixbuf;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp19_ = gdk_pixbuf_get_width (_tmp18_);
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp20_ = _tmp19_;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		aspect = ((gdouble) _tmp17_) / ((gdouble) _tmp20_);
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp21_ = size;
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		scaled_width = _tmp21_;
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp22_ = pixbuf;
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp23_ = gdk_pixbuf_get_height (_tmp22_);
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp24_ = _tmp23_;
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp25_ = aspect;
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp26_ = round (((gdouble) _tmp24_) * _tmp25_);
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		scaled_height = (gint) _tmp26_;
#line 619 "icon-factory.c"
	} else {
		gdouble aspect = 0.0;
		gint _tmp27_;
		GdkPixbuf* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		GdkPixbuf* _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		gdouble _tmp34_;
		gdouble _tmp35_;
		gint _tmp36_;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp27_ = size;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp28_ = pixbuf;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp29_ = gdk_pixbuf_get_height (_tmp28_);
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp30_ = _tmp29_;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		aspect = ((gdouble) _tmp27_) / ((gdouble) _tmp30_);
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp31_ = pixbuf;
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp32_ = gdk_pixbuf_get_width (_tmp31_);
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp33_ = _tmp32_;
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp34_ = aspect;
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp35_ = round (((gdouble) _tmp33_) * _tmp34_);
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		scaled_width = (gint) _tmp35_;
#line 104 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp36_ = size;
#line 104 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		scaled_height = _tmp36_;
#line 658 "icon-factory.c"
	}
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp37_ = pixbuf;
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp38_ = scaled_width;
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp39_ = scaled_height;
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp40_ = gdk_pixbuf_scale_simple (_tmp37_, _tmp38_, _tmp39_, GDK_INTERP_BILINEAR);
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	result = _tmp40_;
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return result;
#line 672 "icon-factory.c"
}


GdkPixbuf* icon_factory_load_symbolic (IconFactory* self, const gchar* icon_name, gint size, GtkStyleContext* style, GtkIconLookupFlags flags) {
	GdkPixbuf* result = NULL;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	GtkIconLookupFlags _tmp3_;
	GtkIconInfo* _tmp4_;
	GtkIconInfo* _tmp5_;
	gint _tmp14_;
	GtkIconLookupFlags _tmp15_;
	GdkPixbuf* _tmp16_;
	GError * _inner_error_ = NULL;
#line 110 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 110 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 110 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (GTK_IS_STYLE_CONTEXT (style), NULL);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp1_ = icon_name;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp2_ = size;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp3_ = flags;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp4_ = gtk_icon_theme_lookup_icon (_tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	icon_info = _tmp4_;
#line 115 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp5_ = icon_info;
#line 115 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (_tmp5_ != NULL) {
#line 711 "icon-factory.c"
		{
			GdkPixbuf* _tmp6_ = NULL;
			GtkIconInfo* _tmp7_;
			GtkStyleContext* _tmp8_;
			GdkPixbuf* _tmp9_;
			gint _tmp10_;
			GdkPixbuf* _tmp11_;
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp7_ = icon_info;
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp8_ = style;
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp9_ = gtk_icon_info_load_symbolic_for_context (_tmp7_, _tmp8_, NULL, &_inner_error_);
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp6_ = _tmp9_;
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 729 "icon-factory.c"
				goto __catch66_g_error;
			}
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp10_ = size;
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp11_ = icon_factory_aspect_scale_down_pixbuf (self, _tmp6_, _tmp10_);
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			result = _tmp11_;
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_g_object_unref0 (_tmp6_);
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 117 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			return result;
#line 744 "icon-factory.c"
		}
		goto __finally66;
		__catch66_g_error:
		{
			GError* e = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			e = _inner_error_;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_inner_error_ = NULL;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp12_ = e;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp13_ = _tmp12_->message;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			g_message ("icon-factory.vala:119: Couldn't load icon: %s", _tmp13_);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_g_error_free0 (e);
#line 764 "icon-factory.c"
		}
		__finally66:
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			g_clear_error (&_inner_error_);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			return NULL;
#line 777 "icon-factory.c"
		}
	}
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp14_ = size;
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp15_ = flags;
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp16_ = icon_factory_get_missing_icon (self, _tmp14_, _tmp15_);
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	result = _tmp16_;
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_gtk_icon_info_free0 (icon_info);
#line 124 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return result;
#line 792 "icon-factory.c"
}


/**
     * Loads a symbolic icon into a pixbuf, where the color-key has been switched to the provided
     * color.
     */
GdkPixbuf* icon_factory_load_symbolic_colored (IconFactory* self, const gchar* icon_name, gint size, GdkRGBA* color, GtkIconLookupFlags flags) {
	GdkPixbuf* result = NULL;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	GtkIconLookupFlags _tmp3_;
	GtkIconInfo* _tmp4_;
	GtkIconInfo* _tmp5_;
	gint _tmp14_;
	GtkIconLookupFlags _tmp15_;
	GdkPixbuf* _tmp16_;
	GError * _inner_error_ = NULL;
#line 131 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 131 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 131 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (color != NULL, NULL);
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp1_ = icon_name;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp2_ = size;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp3_ = flags;
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp4_ = gtk_icon_theme_lookup_icon (_tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 133 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	icon_info = _tmp4_;
#line 136 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp5_ = icon_info;
#line 136 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (_tmp5_ != NULL) {
#line 835 "icon-factory.c"
		{
			GdkPixbuf* _tmp6_ = NULL;
			GtkIconInfo* _tmp7_;
			GdkRGBA _tmp8_;
			GdkPixbuf* _tmp9_;
			gint _tmp10_;
			GdkPixbuf* _tmp11_;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp7_ = icon_info;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp8_ = *color;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp9_ = gtk_icon_info_load_symbolic (_tmp7_, &_tmp8_, NULL, NULL, NULL, NULL, &_inner_error_);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp6_ = _tmp9_;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 853 "icon-factory.c"
				goto __catch67_g_error;
			}
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp10_ = size;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp11_ = icon_factory_aspect_scale_down_pixbuf (self, _tmp6_, _tmp10_);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			result = _tmp11_;
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_g_object_unref0 (_tmp6_);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 138 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			return result;
#line 868 "icon-factory.c"
		}
		goto __finally67;
		__catch67_g_error:
		{
			GError* e = NULL;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			e = _inner_error_;
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_inner_error_ = NULL;
#line 140 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp12_ = e;
#line 140 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_tmp13_ = _tmp12_->message;
#line 140 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			g_warning ("icon-factory.vala:140: Couldn't load icon: %s", _tmp13_);
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_g_error_free0 (e);
#line 888 "icon-factory.c"
		}
		__finally67:
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			_gtk_icon_info_free0 (icon_info);
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			g_clear_error (&_inner_error_);
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			return NULL;
#line 901 "icon-factory.c"
		}
	}
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp14_ = size;
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp15_ = flags;
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp16_ = icon_factory_get_missing_icon (self, _tmp14_, _tmp15_);
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	result = _tmp16_;
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_gtk_icon_info_free0 (icon_info);
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return result;
#line 916 "icon-factory.c"
}


IconFactory* icon_factory_get_instance (void) {
	IconFactory* result;
	IconFactory* _tmp0_;
	IconFactory* _tmp2_;
#line 15 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = icon_factory__instance;
#line 15 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (_tmp0_ == NULL) {
#line 928 "icon-factory.c"
		IconFactory* _tmp1_;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_tmp1_ = icon_factory_new ();
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		_icon_factory_unref0 (icon_factory__instance);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		icon_factory__instance = _tmp1_;
#line 936 "icon-factory.c"
	}
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp2_ = icon_factory__instance;
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	result = _tmp2_;
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return result;
#line 944 "icon-factory.c"
}


static gpointer _icon_factory_ref0 (gpointer self) {
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return self ? icon_factory_ref (self) : NULL;
#line 951 "icon-factory.c"
}


static void icon_factory_set_instance (IconFactory* value) {
	IconFactory* _tmp0_;
	IconFactory* _tmp1_;
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = value;
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp1_ = _icon_factory_ref0 (_tmp0_);
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_icon_factory_unref0 (icon_factory__instance);
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	icon_factory__instance = _tmp1_;
#line 966 "icon-factory.c"
}


static GtkIconTheme* icon_factory_get_icon_theme (IconFactory* self) {
	GtkIconTheme* result;
	GtkIconTheme* _tmp0_;
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (IS_ICON_FACTORY (self), NULL);
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = self->priv->_icon_theme;
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	result = _tmp0_;
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return result;
#line 981 "icon-factory.c"
}


static void icon_factory_set_icon_theme (IconFactory* self, GtkIconTheme* value) {
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_if_fail (IS_ICON_FACTORY (self));
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp0_ = value;
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->_icon_theme);
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	self->priv->_icon_theme = _tmp1_;
#line 998 "icon-factory.c"
}


static void value_icon_factory_init (GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	value->data[0].v_pointer = NULL;
#line 1005 "icon-factory.c"
}


static void value_icon_factory_free_value (GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		icon_factory_unref (value->data[0].v_pointer);
#line 1014 "icon-factory.c"
	}
}


static void value_icon_factory_copy_value (const GValue* src_value, GValue* dest_value) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (src_value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		dest_value->data[0].v_pointer = icon_factory_ref (src_value->data[0].v_pointer);
#line 1024 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1028 "icon-factory.c"
	}
}


static gpointer value_icon_factory_peek_pointer (const GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return value->data[0].v_pointer;
#line 1036 "icon-factory.c"
}


static gchar* value_icon_factory_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (collect_values[0].v_pointer) {
#line 1043 "icon-factory.c"
		IconFactory * object;
		object = collect_values[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		if (object->parent_instance.g_class == NULL) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1050 "icon-factory.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1054 "icon-factory.c"
		}
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = icon_factory_ref (object);
#line 1058 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1062 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return NULL;
#line 1066 "icon-factory.c"
}


static gchar* value_icon_factory_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	IconFactory ** object_p;
	object_p = collect_values[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (!object_p) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1077 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (!value->data[0].v_pointer) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		*object_p = NULL;
#line 1083 "icon-factory.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		*object_p = value->data[0].v_pointer;
#line 1087 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		*object_p = icon_factory_ref (value->data[0].v_pointer);
#line 1091 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return NULL;
#line 1095 "icon-factory.c"
}


GParamSpec* param_spec_icon_factory (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecIconFactory* spec;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_ICON_FACTORY), NULL);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return G_PARAM_SPEC (spec);
#line 1109 "icon-factory.c"
}


gpointer value_get_icon_factory (const GValue* value) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY), NULL);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return value->data[0].v_pointer;
#line 1118 "icon-factory.c"
}


void value_set_icon_factory (GValue* value, gpointer v_object) {
	IconFactory * old;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	old = value->data[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (v_object) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = v_object;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		icon_factory_ref (value->data[0].v_pointer);
#line 1138 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1142 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (old) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		icon_factory_unref (old);
#line 1148 "icon-factory.c"
	}
}


void value_take_icon_factory (GValue* value, gpointer v_object) {
	IconFactory * old;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	old = value->data[0].v_pointer;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (v_object) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_ICON_FACTORY));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = v_object;
#line 1167 "icon-factory.c"
	} else {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		value->data[0].v_pointer = NULL;
#line 1171 "icon-factory.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (old) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		icon_factory_unref (old);
#line 1177 "icon-factory.c"
	}
}


static void icon_factory_class_init (IconFactoryClass * klass) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	icon_factory_parent_class = g_type_class_peek_parent (klass);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	((IconFactoryClass *) klass)->finalize = icon_factory_finalize;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_type_class_add_private (klass, sizeof (IconFactoryPrivate));
#line 1189 "icon-factory.c"
}


static void icon_factory_instance_init (IconFactory * self) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	self->priv = ICON_FACTORY_GET_PRIVATE (self);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	self->ref_count = 1;
#line 1198 "icon-factory.c"
}


static void icon_factory_finalize (IconFactory * obj) {
	IconFactory * self;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_FACTORY, IconFactory);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_signal_handlers_destroy (self);
#line 27 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->_icon_theme);
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	_g_object_unref0 (self->priv->icons_dir);
#line 1212 "icon-factory.c"
}


GType icon_factory_get_type (void) {
	static volatile gsize icon_factory_type_id__volatile = 0;
	if (g_once_init_enter (&icon_factory_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_icon_factory_init, value_icon_factory_free_value, value_icon_factory_copy_value, value_icon_factory_peek_pointer, "p", value_icon_factory_collect_value, "p", value_icon_factory_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (IconFactoryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_factory_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconFactory), 0, (GInstanceInitFunc) icon_factory_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType icon_factory_type_id;
		icon_factory_type_id = g_type_register_fundamental (g_type_fundamental_next (), "IconFactory", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&icon_factory_type_id__volatile, icon_factory_type_id);
	}
	return icon_factory_type_id__volatile;
}


gpointer icon_factory_ref (gpointer instance) {
	IconFactory * self;
	self = instance;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	g_atomic_int_inc (&self->ref_count);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	return instance;
#line 1237 "icon-factory.c"
}


void icon_factory_unref (gpointer instance) {
	IconFactory * self;
	self = instance;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		ICON_FACTORY_GET_CLASS (self)->finalize (self);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/components/icon-factory.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1250 "icon-factory.c"
	}
}



