/* email-entry.c generated by valac 0.36.12, the Vala compiler
 * generated from email-entry.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* A custom entry for e-mail addresses*/

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <geary-engine.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_EMAIL_ENTRY (email_entry_get_type ())
#define EMAIL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EMAIL_ENTRY, EmailEntry))
#define EMAIL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EMAIL_ENTRY, EmailEntryClass))
#define IS_EMAIL_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EMAIL_ENTRY))
#define IS_EMAIL_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EMAIL_ENTRY))
#define EMAIL_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EMAIL_ENTRY, EmailEntryClass))

typedef struct _EmailEntry EmailEntry;
typedef struct _EmailEntryClass EmailEntryClass;
typedef struct _EmailEntryPrivate EmailEntryPrivate;

#define TYPE_COMPOSER_WIDGET (composer_widget_get_type ())
#define COMPOSER_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPOSER_WIDGET, ComposerWidget))
#define COMPOSER_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPOSER_WIDGET, ComposerWidgetClass))
#define IS_COMPOSER_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPOSER_WIDGET))
#define IS_COMPOSER_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPOSER_WIDGET))
#define COMPOSER_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPOSER_WIDGET, ComposerWidgetClass))

typedef struct _ComposerWidget ComposerWidget;
typedef struct _ComposerWidgetClass ComposerWidgetClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_CONTACT_ENTRY_COMPLETION (contact_entry_completion_get_type ())
#define CONTACT_ENTRY_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletion))
#define CONTACT_ENTRY_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletionClass))
#define IS_CONTACT_ENTRY_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTACT_ENTRY_COMPLETION))
#define IS_CONTACT_ENTRY_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTACT_ENTRY_COMPLETION))
#define CONTACT_ENTRY_COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletionClass))

typedef struct _ContactEntryCompletion ContactEntryCompletion;
typedef struct _ContactEntryCompletionClass ContactEntryCompletionClass;

struct _EmailEntry {
	GtkEntry parent_instance;
	EmailEntryPrivate * priv;
	gboolean modified;
};

struct _EmailEntryClass {
	GtkEntryClass parent_class;
};

struct _EmailEntryPrivate {
	gboolean _valid;
	gboolean _empty;
	GearyRFC822MailboxAddresses* _addresses;
	ComposerWidget* composer;
	gboolean updating;
};


static gpointer email_entry_parent_class = NULL;

GType email_entry_get_type (void) G_GNUC_CONST;
GType composer_widget_get_type (void) G_GNUC_CONST;
#define EMAIL_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_EMAIL_ENTRY, EmailEntryPrivate))
enum  {
	EMAIL_ENTRY_0_PROPERTY,
	EMAIL_ENTRY_VALID_PROPERTY,
	EMAIL_ENTRY_EMPTY_PROPERTY,
	EMAIL_ENTRY_ADDRESSES_PROPERTY
};
EmailEntry* email_entry_new (ComposerWidget* composer);
EmailEntry* email_entry_construct (GType object_type, ComposerWidget* composer);
static void email_entry_on_changed (EmailEntry* self);
static void _email_entry_on_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static gboolean email_entry_on_key_press (EmailEntry* self, GtkWidget* widget, GdkEventKey* event);
static gboolean _email_entry_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static void __lambda16_ (EmailEntry* self);
static void email_entry_validate_addresses (EmailEntry* self);
GearyRFC822MailboxAddresses* email_entry_get_addresses (EmailEntry* self);
static void ___lambda16__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
GType contact_entry_completion_get_type (void) G_GNUC_CONST;
void contact_entry_completion_reset_selection (ContactEntryCompletion* self);
void email_entry_set_addresses (EmailEntry* self, GearyRFC822MailboxAddresses* value);
void email_entry_set_valid (EmailEntry* self, gboolean value);
void email_entry_set_empty (EmailEntry* self, gboolean value);
void contact_entry_completion_trigger_selection (ContactEntryCompletion* self);
gboolean email_entry_get_valid (EmailEntry* self);
gboolean email_entry_get_empty (EmailEntry* self);
static void email_entry_finalize (GObject * obj);
static void _vala_email_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_email_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _email_entry_on_changed_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
#line 24 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	email_entry_on_changed ((EmailEntry*) self);
#line 110 "email-entry.c"
}


static gboolean _email_entry_on_key_press_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = email_entry_on_key_press ((EmailEntry*) self, _sender, event);
#line 25 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	return result;
#line 119 "email-entry.c"
}


static void __lambda16_ (EmailEntry* self) {
	gboolean _tmp0_;
	gchar* _tmp1_ = NULL;
	GearyRFC822MailboxAddresses* _tmp2_;
#line 29 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	email_entry_validate_addresses (self);
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp0_ = self->priv->updating;
#line 30 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (_tmp0_) {
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		return;
#line 135 "email-entry.c"
	}
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv->updating = TRUE;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->modified = TRUE;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp2_ = self->priv->_addresses;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (_tmp2_ == NULL) {
#line 145 "email-entry.c"
		gchar* _tmp3_;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp3_ = g_strdup ("");
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_g_free0 (_tmp1_);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp1_ = _tmp3_;
#line 153 "email-entry.c"
	} else {
		GearyRFC822MailboxAddresses* _tmp4_;
		gchar* _tmp5_;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp4_ = self->priv->_addresses;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp5_ = geary_rf_c822_mailbox_addresses_to_rfc822_string (_tmp4_);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_g_free0 (_tmp1_);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp1_ = _tmp5_;
#line 165 "email-entry.c"
	}
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry), _tmp1_);
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv->updating = FALSE;
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_g_free0 (_tmp1_);
#line 173 "email-entry.c"
}


static void ___lambda16__g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	__lambda16_ ((EmailEntry*) self);
#line 180 "email-entry.c"
}


EmailEntry* email_entry_construct (GType object_type, ComposerWidget* composer) {
	EmailEntry * self = NULL;
	ComposerWidget* _tmp0_;
#line 23 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_COMPOSER_WIDGET (composer), NULL);
#line 23 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self = (EmailEntry*) g_object_new (object_type, NULL);
#line 24 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_EDITABLE, GtkEditable), "changed", (GCallback) _email_entry_on_changed_gtk_editable_changed, self, 0);
#line 25 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), "key-press-event", (GCallback) _email_entry_on_key_press_gtk_widget_key_press_event, self, 0);
#line 26 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp0_ = composer;
#line 26 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv->composer = _tmp0_;
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (self, G_TYPE_OBJECT, GObject), "notify::addresses", (GCallback) ___lambda16__g_object_notify, self, 0);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 23 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	return self;
#line 205 "email-entry.c"
}


EmailEntry* email_entry_new (ComposerWidget* composer) {
#line 23 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	return email_entry_construct (TYPE_EMAIL_ENTRY, composer);
#line 212 "email-entry.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 47 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	return self ? g_object_ref (self) : NULL;
#line 219 "email-entry.c"
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1234 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1235 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1235 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1236 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1236 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1237 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _result_;
#line 1237 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 242 "email-entry.c"
}


static void email_entry_on_changed (EmailEntry* self) {
	gboolean _tmp0_;
	ContactEntryCompletion* completion = NULL;
	GtkEntryCompletion* _tmp1_;
	ContactEntryCompletion* _tmp2_;
	ContactEntryCompletion* _tmp3_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GearyRFC822MailboxAddresses* _tmp13_;
	GearyRFC822MailboxAddresses* _tmp14_;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp0_ = self->priv->updating;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (_tmp0_) {
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		return;
#line 270 "email-entry.c"
	}
#line 45 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->modified = TRUE;
#line 47 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp1_ = gtk_entry_get_completion (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 47 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, TYPE_CONTACT_ENTRY_COMPLETION) ? ((ContactEntryCompletion*) _tmp1_) : NULL);
#line 47 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	completion = _tmp2_;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp3_ = completion;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (_tmp3_ != NULL) {
#line 284 "email-entry.c"
		ContactEntryCompletion* _tmp4_;
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp4_ = completion;
#line 49 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		contact_entry_completion_reset_selection (_tmp4_);
#line 290 "email-entry.c"
	}
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp5_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp6_ = _tmp5_;
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp7_ = string_strip (_tmp6_);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp8_ = _tmp7_;
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp9_ = geary_string_is_empty (_tmp8_);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp10_ = _tmp9_;
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_g_free0 (_tmp8_);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (_tmp10_) {
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		self->priv->updating = TRUE;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		email_entry_set_addresses (self, NULL);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		self->priv->updating = FALSE;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		email_entry_set_valid (self, FALSE);
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		email_entry_set_empty (self, TRUE);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_g_object_unref0 (completion);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		return;
#line 322 "email-entry.c"
	}
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv->updating = TRUE;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp11_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp12_ = _tmp11_;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp13_ = geary_rf_c822_mailbox_addresses_new_from_rfc822_string (_tmp12_);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp14_ = _tmp13_;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	email_entry_set_addresses (self, _tmp14_);
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_g_object_unref0 (_tmp14_);
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv->updating = FALSE;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_g_object_unref0 (completion);
#line 342 "email-entry.c"
}


static void email_entry_validate_addresses (EmailEntry* self) {
	gboolean _tmp0_ = FALSE;
	GearyRFC822MailboxAddresses* _tmp1_;
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp1_ = self->priv->_addresses;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (_tmp1_ == NULL) {
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp0_ = TRUE;
#line 357 "email-entry.c"
	} else {
		GearyRFC822MailboxAddresses* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp2_ = self->priv->_addresses;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp3_ = geary_rf_c822_mailbox_addresses_get_size (_tmp2_);
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp4_ = _tmp3_;
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp0_ = _tmp4_ == 0;
#line 370 "email-entry.c"
	}
#line 67 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (_tmp0_) {
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		email_entry_set_valid (self, FALSE);
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		email_entry_set_empty (self, TRUE);
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		return;
#line 380 "email-entry.c"
	}
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	email_entry_set_empty (self, FALSE);
#line 384 "email-entry.c"
	{
		GearyRFC822MailboxAddresses* _address_list = NULL;
		GearyRFC822MailboxAddresses* _tmp5_;
		GearyRFC822MailboxAddresses* _tmp6_;
		gint _address_size = 0;
		GearyRFC822MailboxAddresses* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint _address_index = 0;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp5_ = self->priv->_addresses;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_address_list = _tmp6_;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp7_ = _address_list;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp8_ = geary_rf_c822_mailbox_addresses_get_size (_tmp7_);
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp9_ = _tmp8_;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_address_size = _tmp9_;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_address_index = -1;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		while (TRUE) {
#line 412 "email-entry.c"
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			GearyRFC822MailboxAddress* address = NULL;
			GearyRFC822MailboxAddresses* _tmp13_;
			gint _tmp14_;
			GearyRFC822MailboxAddress* _tmp15_;
			GearyRFC822MailboxAddress* _tmp16_;
			gboolean _tmp17_;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_tmp10_ = _address_index;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_address_index = _tmp10_ + 1;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_tmp11_ = _address_index;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_tmp12_ = _address_size;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			if (!(_tmp11_ < _tmp12_)) {
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
				break;
#line 434 "email-entry.c"
			}
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_tmp13_ = _address_list;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_tmp14_ = _address_index;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_tmp15_ = geary_rf_c822_mailbox_addresses_get (_tmp13_, _tmp14_);
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			address = _tmp15_;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_tmp16_ = address;
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_tmp17_ = geary_rf_c822_mailbox_address_is_valid (_tmp16_);
#line 75 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			if (!_tmp17_) {
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
				email_entry_set_valid (self, FALSE);
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
				_g_object_unref0 (address);
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
				_g_object_unref0 (_address_list);
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
				return;
#line 458 "email-entry.c"
			}
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
			_g_object_unref0 (address);
#line 462 "email-entry.c"
		}
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_g_object_unref0 (_address_list);
#line 466 "email-entry.c"
	}
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	email_entry_set_valid (self, TRUE);
#line 470 "email-entry.c"
}


static gboolean email_entry_on_key_press (EmailEntry* self, GtkWidget* widget, GdkEventKey* event) {
	gboolean result = FALSE;
	GdkEventKey* _tmp0_;
	guint _tmp1_;
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), FALSE);
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_val_if_fail (GTK_IS_WIDGET (widget), FALSE);
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp0_ = event;
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp1_ = _tmp0_->keyval;
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (_tmp1_ == ((guint) GDK_KEY_Tab)) {
#line 490 "email-entry.c"
		GtkEntryCompletion* _tmp2_;
		ComposerWidget* _tmp3_;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp2_ = gtk_entry_get_completion (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry));
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		contact_entry_completion_trigger_selection (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_CONTACT_ENTRY_COMPLETION, ContactEntryCompletion));
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp3_ = self->priv->composer;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		gtk_widget_child_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), GTK_DIR_TAB_FORWARD);
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		result = TRUE;
#line 87 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		return result;
#line 505 "email-entry.c"
	}
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	result = FALSE;
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	return result;
#line 511 "email-entry.c"
}


gboolean email_entry_get_valid (EmailEntry* self) {
	gboolean result;
	gboolean _tmp0_;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), FALSE);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp0_ = self->priv->_valid;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	result = _tmp0_;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	return result;
#line 526 "email-entry.c"
}


void email_entry_set_valid (EmailEntry* self, gboolean value) {
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (email_entry_get_valid (self) != value) {
#line 535 "email-entry.c"
		gboolean _tmp0_;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp0_ = value;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		self->priv->_valid = _tmp0_;
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		g_object_notify ((GObject *) self, "valid");
#line 543 "email-entry.c"
	}
}


gboolean email_entry_get_empty (EmailEntry* self) {
	gboolean result;
	gboolean _tmp0_;
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), FALSE);
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp0_ = self->priv->_empty;
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	result = _tmp0_;
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	return result;
#line 559 "email-entry.c"
}


void email_entry_set_empty (EmailEntry* self, gboolean value) {
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (email_entry_get_empty (self) != value) {
#line 568 "email-entry.c"
		gboolean _tmp0_;
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp0_ = value;
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		self->priv->_empty = _tmp0_;
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		g_object_notify ((GObject *) self, "empty");
#line 576 "email-entry.c"
	}
}


GearyRFC822MailboxAddresses* email_entry_get_addresses (EmailEntry* self) {
	GearyRFC822MailboxAddresses* result;
	GearyRFC822MailboxAddresses* _tmp0_;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_val_if_fail (IS_EMAIL_ENTRY (self), NULL);
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_tmp0_ = self->priv->_addresses;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	result = _tmp0_;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	return result;
#line 592 "email-entry.c"
}


void email_entry_set_addresses (EmailEntry* self, GearyRFC822MailboxAddresses* value) {
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_return_if_fail (IS_EMAIL_ENTRY (self));
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	if (email_entry_get_addresses (self) != value) {
#line 601 "email-entry.c"
		GearyRFC822MailboxAddresses* _tmp0_;
		GearyRFC822MailboxAddresses* _tmp1_;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp0_ = value;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		_g_object_unref0 (self->priv->_addresses);
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		self->priv->_addresses = _tmp1_;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		g_object_notify ((GObject *) self, "addresses");
#line 614 "email-entry.c"
	}
}


static void email_entry_class_init (EmailEntryClass * klass) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	email_entry_parent_class = g_type_class_peek_parent (klass);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_type_class_add_private (klass, sizeof (EmailEntryPrivate));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_email_entry_get_property;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_email_entry_set_property;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	G_OBJECT_CLASS (klass)->finalize = email_entry_finalize;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EMAIL_ENTRY_VALID_PROPERTY, g_param_spec_boolean ("valid", "valid", "valid", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EMAIL_ENTRY_EMPTY_PROPERTY, g_param_spec_boolean ("empty", "empty", "empty", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), EMAIL_ENTRY_ADDRESSES_PROPERTY, g_param_spec_object ("addresses", "addresses", "addresses", GEARY_RF_C822_TYPE_MAILBOX_ADDRESSES, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 636 "email-entry.c"
}


static void email_entry_instance_init (EmailEntry * self) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv = EMAIL_ENTRY_GET_PRIVATE (self);
#line 10 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv->_valid = FALSE;
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv->_empty = TRUE;
#line 14 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->modified = FALSE;
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv->_addresses = NULL;
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self->priv->updating = FALSE;
#line 653 "email-entry.c"
}


static void email_entry_finalize (GObject * obj) {
	EmailEntry * self;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EMAIL_ENTRY, EmailEntry);
#line 17 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	_g_object_unref0 (self->priv->_addresses);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	G_OBJECT_CLASS (email_entry_parent_class)->finalize (obj);
#line 665 "email-entry.c"
}


GType email_entry_get_type (void) {
	static volatile gsize email_entry_type_id__volatile = 0;
	if (g_once_init_enter (&email_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (EmailEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) email_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EmailEntry), 0, (GInstanceInitFunc) email_entry_instance_init, NULL };
		GType email_entry_type_id;
		email_entry_type_id = g_type_register_static (gtk_entry_get_type (), "EmailEntry", &g_define_type_info, 0);
		g_once_init_leave (&email_entry_type_id__volatile, email_entry_type_id);
	}
	return email_entry_type_id__volatile;
}


static void _vala_email_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	EmailEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EMAIL_ENTRY, EmailEntry);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	switch (property_id) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_VALID_PROPERTY:
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		g_value_set_boolean (value, email_entry_get_valid (self));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_EMPTY_PROPERTY:
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		g_value_set_boolean (value, email_entry_get_empty (self));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_ADDRESSES_PROPERTY:
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		g_value_set_object (value, email_entry_get_addresses (self));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		break;
#line 704 "email-entry.c"
		default:
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		break;
#line 710 "email-entry.c"
	}
}


static void _vala_email_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	EmailEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_EMAIL_ENTRY, EmailEntry);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
	switch (property_id) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_VALID_PROPERTY:
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		email_entry_set_valid (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_EMPTY_PROPERTY:
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		email_entry_set_empty (self, g_value_get_boolean (value));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		break;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		case EMAIL_ENTRY_ADDRESSES_PROPERTY:
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		email_entry_set_addresses (self, g_value_get_object (value));
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		break;
#line 738 "email-entry.c"
		default:
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/composer/email-entry.vala"
		break;
#line 744 "email-entry.c"
	}
}



