/* attachment-dialog.c generated by valac 0.36.12, the Vala compiler
 * generated from attachment-dialog.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <geary-engine.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_ATTACHMENT_DIALOG (attachment_dialog_get_type ())
#define ATTACHMENT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ATTACHMENT_DIALOG, AttachmentDialog))
#define ATTACHMENT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ATTACHMENT_DIALOG, AttachmentDialogClass))
#define IS_ATTACHMENT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ATTACHMENT_DIALOG))
#define IS_ATTACHMENT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ATTACHMENT_DIALOG))
#define ATTACHMENT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ATTACHMENT_DIALOG, AttachmentDialogClass))

typedef struct _AttachmentDialog AttachmentDialog;
typedef struct _AttachmentDialogClass AttachmentDialogClass;
typedef struct _AttachmentDialogPrivate AttachmentDialogPrivate;

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
#define _configuration_unref0(var) ((var == NULL) ? NULL : (var = (configuration_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GdkPixbufFormat_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkPixbufFormat_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _AttachmentDialog {
	GObject parent_instance;
	AttachmentDialogPrivate * priv;
};

struct _AttachmentDialogClass {
	GObjectClass parent_class;
};

struct _AttachmentDialogPrivate {
	Configuration* config;
	GtkFileChooserNative* chooser;
	GtkImage* preview_image;
};

typedef gboolean (*AttachmentDialogAttacher) (GFile* attachment_file, gboolean alert_errors, void* user_data);

static gpointer attachment_dialog_parent_class = NULL;

GType attachment_dialog_get_type (void) G_GNUC_CONST;
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_configuration (GValue* value, gpointer v_object);
void value_take_configuration (GValue* value, gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
#define ATTACHMENT_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_ATTACHMENT_DIALOG, AttachmentDialogPrivate))
enum  {
	ATTACHMENT_DIALOG_0_PROPERTY
};
#define ATTACHMENT_DIALOG_PREVIEW_SIZE 180
#define ATTACHMENT_DIALOG_PREVIEW_PADDING 3
AttachmentDialog* attachment_dialog_new (GtkWindow* parent, Configuration* config);
AttachmentDialog* attachment_dialog_construct (GType object_type, GtkWindow* parent, Configuration* config);
#define STOCK__CANCEL _ ("_Cancel")
gchar* configuration_get_attachments_dir (Configuration* self);
static void attachment_dialog_on_update_preview (AttachmentDialog* self);
static void _attachment_dialog_on_update_preview_gtk_file_chooser_update_preview (GtkFileChooser* _sender, gpointer self);
void attachment_dialog_add_filter (AttachmentDialog* self, GtkFileFilter* filter);
GSList* attachment_dialog_get_files (AttachmentDialog* self);
gint attachment_dialog_run (AttachmentDialog* self);
void configuration_set_attachments_dir (Configuration* self, const gchar* value);
void attachment_dialog_hide (AttachmentDialog* self);
void attachment_dialog_destroy (AttachmentDialog* self);
static GdkPixbufFormat* _vala_GdkPixbufFormat_copy (GdkPixbufFormat* self);
static void _vala_GdkPixbufFormat_free (GdkPixbufFormat* self);
static void attachment_dialog_finalize (GObject * obj);


static gpointer _configuration_ref0 (gpointer self) {
#line 25 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	return self ? configuration_ref (self) : NULL;
#line 101 "attachment-dialog.c"
}


static void _attachment_dialog_on_update_preview_gtk_file_chooser_update_preview (GtkFileChooser* _sender, gpointer self) {
#line 45 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	attachment_dialog_on_update_preview ((AttachmentDialog*) self);
#line 108 "attachment-dialog.c"
}


AttachmentDialog* attachment_dialog_construct (GType object_type, GtkWindow* parent, Configuration* config) {
	AttachmentDialog * self = NULL;
	Configuration* _tmp0_;
	Configuration* _tmp1_;
	GtkWindow* _tmp2_;
	GtkFileChooserNative* _tmp3_;
	gchar* dir = NULL;
	Configuration* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp8_;
	GtkFileChooserNative* _tmp11_;
	GtkFileChooserNative* _tmp12_;
	GtkFileChooserNative* _tmp13_;
	GtkImage* _tmp14_;
	GtkFileChooserNative* _tmp15_;
	GtkFileChooserNative* _tmp16_;
#line 24 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_return_val_if_fail ((parent == NULL) || GTK_IS_WINDOW (parent), NULL);
#line 24 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_return_val_if_fail (IS_CONFIGURATION (config), NULL);
#line 24 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	self = (AttachmentDialog*) g_object_new (object_type, NULL);
#line 25 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = config;
#line 25 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp1_ = _configuration_ref0 (_tmp0_);
#line 25 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_configuration_unref0 (self->priv->config);
#line 25 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	self->priv->config = _tmp1_;
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp2_ = parent;
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp3_ = gtk_file_chooser_native_new (_ ("Choose a file"), _tmp2_, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("_Attach"), STOCK__CANCEL);
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (self->priv->chooser);
#line 28 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	self->priv->chooser = _tmp3_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp4_ = config;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp5_ = configuration_get_attachments_dir (_tmp4_);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp6_ = _tmp5_;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	dir = _tmp6_;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp7_ = dir;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp8_ = geary_string_is_empty (_tmp7_);
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	if (!_tmp8_) {
#line 166 "attachment-dialog.c"
		GtkFileChooserNative* _tmp9_;
		const gchar* _tmp10_;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp9_ = self->priv->chooser;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp10_ = dir;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		gtk_file_chooser_set_current_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), _tmp10_);
#line 175 "attachment-dialog.c"
	}
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp11_ = self->priv->chooser;
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_local_only (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), FALSE);
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp12_ = self->priv->chooser;
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_select_multiple (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), TRUE);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp13_ = self->priv->chooser;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp14_ = self->priv->preview_image;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_preview_widget (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp15_ = self->priv->chooser;
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_use_preview_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), FALSE);
#line 45 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp16_ = self->priv->chooser;
#line 45 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), "update-preview", (GCallback) _attachment_dialog_on_update_preview_gtk_file_chooser_update_preview, self, 0);
#line 24 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_g_free0 (dir);
#line 24 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	return self;
#line 203 "attachment-dialog.c"
}


AttachmentDialog* attachment_dialog_new (GtkWindow* parent, Configuration* config) {
#line 24 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	return attachment_dialog_construct (TYPE_ATTACHMENT_DIALOG, parent, config);
#line 210 "attachment-dialog.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 217 "attachment-dialog.c"
}


void attachment_dialog_add_filter (AttachmentDialog* self, GtkFileFilter* filter) {
	GtkFileChooserNative* _tmp0_;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* _tmp2_;
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (IS_ATTACHMENT_DIALOG (self));
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (GTK_IS_FILE_FILTER (filter));
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp1_ = filter;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_add_filter (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), _tmp2_);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (filter);
#line 239 "attachment-dialog.c"
}


GSList* attachment_dialog_get_files (AttachmentDialog* self) {
	GSList* result = NULL;
	GtkFileChooserNative* _tmp0_;
	GSList* _tmp1_;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_return_val_if_fail (IS_ATTACHMENT_DIALOG (self), NULL);
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp1_ = gtk_file_chooser_get_files (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	result = _tmp1_;
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	return result;
#line 257 "attachment-dialog.c"
}


gint attachment_dialog_run (AttachmentDialog* self) {
	gint result = 0;
	gint response = 0;
	GtkFileChooserNative* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_return_val_if_fail (IS_ATTACHMENT_DIALOG (self), 0);
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp1_ = gtk_native_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_NATIVE_DIALOG, GtkNativeDialog));
#line 61 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	response = _tmp1_;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp2_ = response;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	if (_tmp2_ == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 279 "attachment-dialog.c"
		Configuration* _tmp3_;
		GtkFileChooserNative* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp3_ = self->priv->config;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp4_ = self->priv->chooser;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp5_ = gtk_file_chooser_get_current_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp6_ = _tmp5_;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		configuration_set_attachments_dir (_tmp3_, _tmp6_);
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_free0 (_tmp6_);
#line 296 "attachment-dialog.c"
	}
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	result = response;
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	return result;
#line 302 "attachment-dialog.c"
}


void attachment_dialog_hide (AttachmentDialog* self) {
	GtkFileChooserNative* _tmp0_;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (IS_ATTACHMENT_DIALOG (self));
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 69 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_native_dialog_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_NATIVE_DIALOG, GtkNativeDialog));
#line 314 "attachment-dialog.c"
}


void attachment_dialog_destroy (AttachmentDialog* self) {
	GtkFileChooserNative* _tmp0_;
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (IS_ATTACHMENT_DIALOG (self));
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 73 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_native_dialog_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_NATIVE_DIALOG, GtkNativeDialog));
#line 326 "attachment-dialog.c"
}


static GdkPixbufFormat* _vala_GdkPixbufFormat_copy (GdkPixbufFormat* self) {
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	return g_boxed_copy (gdk_pixbuf_format_get_type (), self);
#line 333 "attachment-dialog.c"
}


static gpointer __vala_GdkPixbufFormat_copy0 (gpointer self) {
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	return self ? _vala_GdkPixbufFormat_copy (self) : NULL;
#line 340 "attachment-dialog.c"
}


static void _vala_GdkPixbufFormat_free (GdkPixbufFormat* self) {
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_boxed_free (gdk_pixbuf_format_get_type (), self);
#line 347 "attachment-dialog.c"
}


static void attachment_dialog_on_update_preview (AttachmentDialog* self) {
	gchar* filename = NULL;
	GtkFileChooserNative* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint width = 0;
	gint height = 0;
	GdkPixbufFormat* format = NULL;
	const gchar* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	GdkPixbufFormat* _tmp7_;
	GdkPixbufFormat* _tmp8_;
	GdkPixbufFormat* _tmp9_;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp16_;
	GdkPixbuf* _tmp18_;
	GdkPixbuf* _tmp19_;
	gint extra_space = 0;
	GdkPixbuf* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint smaller_half = 0;
	gint _tmp23_;
	gint larger_half = 0;
	gint _tmp24_;
	gint _tmp25_;
	GtkImage* _tmp26_;
	gint _tmp27_;
	GtkImage* _tmp28_;
	gint _tmp29_;
	GtkImage* _tmp30_;
	GdkPixbuf* _tmp31_;
	GtkFileChooserNative* _tmp32_;
	GError * _inner_error_ = NULL;
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_return_if_fail (IS_ATTACHMENT_DIALOG (self));
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = self->priv->chooser;
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp1_ = gtk_file_chooser_get_preview_filename (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
#line 77 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	filename = _tmp1_;
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp2_ = filename;
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	if (_tmp2_ == NULL) {
#line 398 "attachment-dialog.c"
		GtkFileChooserNative* _tmp3_;
#line 79 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp3_ = self->priv->chooser;
#line 79 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), FALSE);
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		return;
#line 408 "attachment-dialog.c"
	}
#line 84 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	width = 0;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	height = 0;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp4_ = filename;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp7_ = gdk_pixbuf_get_file_info (_tmp4_, &_tmp5_, &_tmp6_);
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	width = _tmp5_;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	height = _tmp6_;
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp8_ = __vala_GdkPixbufFormat_copy0 (_tmp7_);
#line 86 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	format = _tmp8_;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp9_ = format;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	if (_tmp9_ == NULL) {
#line 430 "attachment-dialog.c"
		GtkFileChooserNative* _tmp10_;
#line 89 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp10_ = self->priv->chooser;
#line 89 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), FALSE);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		__vala_GdkPixbufFormat_free0 (format);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 90 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		return;
#line 442 "attachment-dialog.c"
	}
	{
		GdkPixbuf* _tmp11_ = NULL;
		const gchar* _tmp12_;
		GdkPixbuf* _tmp13_;
		GdkPixbuf* _tmp14_;
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp12_ = filename;
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp13_ = gdk_pixbuf_new_from_file_at_scale (_tmp12_, ATTACHMENT_DIALOG_PREVIEW_SIZE, ATTACHMENT_DIALOG_PREVIEW_SIZE, TRUE, &_inner_error_);
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp11_ = _tmp13_;
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 457 "attachment-dialog.c"
			goto __catch118_g_error;
		}
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp14_ = _tmp11_;
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp11_ = NULL;
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (pixbuf);
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		pixbuf = _tmp14_;
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (_tmp11_);
#line 470 "attachment-dialog.c"
	}
	goto __finally118;
	__catch118_g_error:
	{
		GError* e = NULL;
		GtkFileChooserNative* _tmp15_;
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		e = _inner_error_;
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_inner_error_ = NULL;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp15_ = self->priv->chooser;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), FALSE);
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_error_free0 (e);
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (pixbuf);
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		__vala_GdkPixbufFormat_free0 (format);
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		return;
#line 495 "attachment-dialog.c"
	}
	__finally118:
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (pixbuf);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		__vala_GdkPixbufFormat_free0 (format);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		g_clear_error (&_inner_error_);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		return;
#line 512 "attachment-dialog.c"
	}
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp16_ = pixbuf;
#line 102 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	if (_tmp16_ == NULL) {
#line 518 "attachment-dialog.c"
		GtkFileChooserNative* _tmp17_;
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_tmp17_ = self->priv->chooser;
#line 103 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), FALSE);
#line 104 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_object_unref0 (pixbuf);
#line 104 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		__vala_GdkPixbufFormat_free0 (format);
#line 104 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		_g_free0 (filename);
#line 104 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
		return;
#line 532 "attachment-dialog.c"
	}
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp18_ = pixbuf;
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp19_ = gdk_pixbuf_apply_embedded_orientation (_tmp18_);
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (pixbuf);
#line 107 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	pixbuf = _tmp19_;
#line 110 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp20_ = pixbuf;
#line 110 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp21_ = gdk_pixbuf_get_width (_tmp20_);
#line 110 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp22_ = _tmp21_;
#line 110 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	extra_space = ATTACHMENT_DIALOG_PREVIEW_SIZE - _tmp22_;
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp23_ = extra_space;
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	smaller_half = _tmp23_ / 2;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp24_ = extra_space;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp25_ = smaller_half;
#line 112 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	larger_half = _tmp24_ - _tmp25_;
#line 115 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp26_ = self->priv->preview_image;
#line 115 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp27_ = smaller_half;
#line 115 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, gtk_widget_get_type (), GtkWidget), ATTACHMENT_DIALOG_PREVIEW_PADDING + _tmp27_);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp28_ = self->priv->preview_image;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp29_ = larger_half;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_widget_get_type (), GtkWidget), ATTACHMENT_DIALOG_PREVIEW_PADDING + _tmp29_);
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp30_ = self->priv->preview_image;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp31_ = pixbuf;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_image_set_from_pixbuf (_tmp30_, _tmp31_);
#line 120 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp32_ = self->priv->chooser;
#line 120 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	gtk_file_chooser_set_preview_widget_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), TRUE);
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (pixbuf);
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	__vala_GdkPixbufFormat_free0 (format);
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_g_free0 (filename);
#line 588 "attachment-dialog.c"
}


static void attachment_dialog_class_init (AttachmentDialogClass * klass) {
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	attachment_dialog_parent_class = g_type_class_peek_parent (klass);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_type_class_add_private (klass, sizeof (AttachmentDialogPrivate));
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = attachment_dialog_finalize;
#line 599 "attachment-dialog.c"
}


static void attachment_dialog_instance_init (AttachmentDialog * self) {
	GtkImage* _tmp0_;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	self->priv = ATTACHMENT_DIALOG_GET_PRIVATE (self);
#line 15 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	self->priv->chooser = NULL;
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_tmp0_ = (GtkImage*) gtk_image_new ();
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	self->priv->preview_image = _tmp0_;
#line 615 "attachment-dialog.c"
}


static void attachment_dialog_finalize (GObject * obj) {
	AttachmentDialog * self;
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ATTACHMENT_DIALOG, AttachmentDialog);
#line 12 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_configuration_unref0 (self->priv->config);
#line 15 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (self->priv->chooser);
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	_g_object_unref0 (self->priv->preview_image);
#line 7 "/builddir/build/BUILD/geary-0.12.2/src/client/dialogs/attachment-dialog.vala"
	G_OBJECT_CLASS (attachment_dialog_parent_class)->finalize (obj);
#line 631 "attachment-dialog.c"
}


GType attachment_dialog_get_type (void) {
	static volatile gsize attachment_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&attachment_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AttachmentDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) attachment_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AttachmentDialog), 0, (GInstanceInitFunc) attachment_dialog_instance_init, NULL };
		GType attachment_dialog_type_id;
		attachment_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "AttachmentDialog", &g_define_type_info, 0);
		g_once_init_leave (&attachment_dialog_type_id__volatile, attachment_dialog_type_id);
	}
	return attachment_dialog_type_id__volatile;
}



