/* util-date.c generated by valac 0.36.12, the Vala compiler
 * generated from util-date.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <locale.h>
#include <glib/gi18n-lib.h>
#include <math.h>
#include <float.h>


#define DATE_TYPE_CLOCK_FORMAT (date_clock_format_get_type ())

#define DATE_TYPE_COARSE_DATE (date_coarse_date_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

typedef enum  {
	DATE_CLOCK_FORMAT_TWELVE_HOURS,
	DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS,
	DATE_CLOCK_FORMAT_LOCALE_DEFAULT,
	DATE_CLOCK_FORMAT_TOTAL
} DateClockFormat;

typedef enum  {
	DATE_COARSE_DATE_NOW,
	DATE_COARSE_DATE_MINUTES,
	DATE_COARSE_DATE_HOURS,
	DATE_COARSE_DATE_TODAY,
	DATE_COARSE_DATE_YESTERDAY,
	DATE_COARSE_DATE_THIS_WEEK,
	DATE_COARSE_DATE_THIS_YEAR,
	DATE_COARSE_DATE_YEARS,
	DATE_COARSE_DATE_FUTURE
} DateCoarseDate;


extern gint date_init_count;
gint date_init_count = 0;
extern gchar** date_xlat_pretty_dates;
extern gint date_xlat_pretty_dates_length1;
gchar** date_xlat_pretty_dates = NULL;
gint date_xlat_pretty_dates_length1 = 0;
static gint _date_xlat_pretty_dates_size_ = 0;
extern gchar** date_xlat_pretty_verbose_dates;
extern gint date_xlat_pretty_verbose_dates_length1;
gchar** date_xlat_pretty_verbose_dates = NULL;
gint date_xlat_pretty_verbose_dates_length1 = 0;
static gint _date_xlat_pretty_verbose_dates_size_ = 0;
extern gchar* date_xlat_same_year;
gchar* date_xlat_same_year = NULL;
extern gchar* date_xlat_diff_year;
gchar* date_xlat_diff_year = NULL;

GType date_clock_format_get_type (void) G_GNUC_CONST;
gint date_clock_format_to_index (DateClockFormat self);
GType date_coarse_date_get_type (void) G_GNUC_CONST;
void date_init (void);
void date_terminate (void);
gboolean date_same_day (GDateTime* a, GDateTime* b);
DateCoarseDate date_as_coarse_date (GDateTime* datetime, GDateTime* now, GTimeSpan diff);
gchar* date_pretty_print_coarse (DateCoarseDate coarse_date, DateClockFormat clock_format, GDateTime* datetime, GTimeSpan diff);
gchar* date_pretty_print (GDateTime* datetime, DateClockFormat clock_format);
gchar* date_pretty_print_verbose (GDateTime* datetime, DateClockFormat clock_format);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


gint date_clock_format_to_index (DateClockFormat self) {
	gint result = 0;
	gint _tmp0_;
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp0_ = CLAMP ((gint) self, 0, (gint) (DATE_CLOCK_FORMAT_TOTAL - 1));
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	result = _tmp0_;
#line 18 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	return result;
#line 87 "util-date.c"
}


GType date_clock_format_get_type (void) {
	static volatile gsize date_clock_format_type_id__volatile = 0;
	if (g_once_init_enter (&date_clock_format_type_id__volatile)) {
		static const GEnumValue values[] = {{DATE_CLOCK_FORMAT_TWELVE_HOURS, "DATE_CLOCK_FORMAT_TWELVE_HOURS", "twelve-hours"}, {DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS, "DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS", "twenty-four-hours"}, {DATE_CLOCK_FORMAT_LOCALE_DEFAULT, "DATE_CLOCK_FORMAT_LOCALE_DEFAULT", "locale-default"}, {DATE_CLOCK_FORMAT_TOTAL, "DATE_CLOCK_FORMAT_TOTAL", "total"}, {0, NULL, NULL}};
		GType date_clock_format_type_id;
		date_clock_format_type_id = g_enum_register_static ("DateClockFormat", values);
		g_once_init_leave (&date_clock_format_type_id__volatile, date_clock_format_type_id);
	}
	return date_clock_format_type_id__volatile;
}


GType date_coarse_date_get_type (void) {
	static volatile gsize date_coarse_date_type_id__volatile = 0;
	if (g_once_init_enter (&date_coarse_date_type_id__volatile)) {
		static const GEnumValue values[] = {{DATE_COARSE_DATE_NOW, "DATE_COARSE_DATE_NOW", "now"}, {DATE_COARSE_DATE_MINUTES, "DATE_COARSE_DATE_MINUTES", "minutes"}, {DATE_COARSE_DATE_HOURS, "DATE_COARSE_DATE_HOURS", "hours"}, {DATE_COARSE_DATE_TODAY, "DATE_COARSE_DATE_TODAY", "today"}, {DATE_COARSE_DATE_YESTERDAY, "DATE_COARSE_DATE_YESTERDAY", "yesterday"}, {DATE_COARSE_DATE_THIS_WEEK, "DATE_COARSE_DATE_THIS_WEEK", "this-week"}, {DATE_COARSE_DATE_THIS_YEAR, "DATE_COARSE_DATE_THIS_YEAR", "this-year"}, {DATE_COARSE_DATE_YEARS, "DATE_COARSE_DATE_YEARS", "years"}, {DATE_COARSE_DATE_FUTURE, "DATE_COARSE_DATE_FUTURE", "future"}, {0, NULL, NULL}};
		GType date_coarse_date_type_id;
		date_coarse_date_type_id = g_enum_register_static ("DateCoarseDate", values);
		g_once_init_leave (&date_coarse_date_type_id__volatile, date_coarse_date_type_id);
	}
	return date_coarse_date_type_id__volatile;
}


void date_init (void) {
	gint _tmp0_;
	gchar* messages_locale = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* time_locale = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* language_env = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar** _tmp29_;
	gint _tmp29__length1;
	gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp34_;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp0_ = date_init_count;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_init_count = _tmp0_ + 1;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	if (_tmp0_ != 0) {
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		return;
#line 166 "util-date.c"
	}
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp1_ = setlocale (LC_MESSAGES, NULL);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	messages_locale = _tmp2_;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp3_ = setlocale (LC_TIME, NULL);
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	time_locale = _tmp4_;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp5_ = g_getenv ("LANGUAGE");
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	language_env = _tmp6_;
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp7_ = language_env;
#line 57 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	if (_tmp7_ != NULL) {
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		g_unsetenv ("LANGUAGE");
#line 192 "util-date.c"
	}
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp8_ = time_locale;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	if (_tmp8_ != NULL) {
#line 198 "util-date.c"
		const gchar* _tmp9_;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp9_ = time_locale;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		setlocale (LC_MESSAGES, _tmp9_);
#line 204 "util-date.c"
	}
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp10_ = g_new0 (gchar*, DATE_CLOCK_FORMAT_TOTAL + 1);
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_dates = (_vala_array_free (date_xlat_pretty_dates, date_xlat_pretty_dates_length1, (GDestroyNotify) g_free), NULL);
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_dates = _tmp10_;
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_dates_length1 = DATE_CLOCK_FORMAT_TOTAL;
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_date_xlat_pretty_dates_size_ = date_xlat_pretty_dates_length1;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp11_ = date_xlat_pretty_dates;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp11__length1 = date_xlat_pretty_dates_length1;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp12_ = g_strdup (_ ("%l:%M %P"));
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (_tmp11_[DATE_CLOCK_FORMAT_TWELVE_HOURS]);
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp11_[DATE_CLOCK_FORMAT_TWELVE_HOURS] = _tmp12_;
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp13_ = _tmp11_[DATE_CLOCK_FORMAT_TWELVE_HOURS];
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp14_ = date_xlat_pretty_dates;
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp14__length1 = date_xlat_pretty_dates_length1;
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp15_ = g_strdup (_ ("%H:%M"));
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (_tmp14_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS]);
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp14_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS] = _tmp15_;
#line 71 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp16_ = _tmp14_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS];
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp17_ = date_xlat_pretty_dates;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp17__length1 = date_xlat_pretty_dates_length1;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp18_ = g_strdup (C_ ("Default clock format", "%l:%M %P"));
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (_tmp17_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT]);
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp17_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT] = _tmp18_;
#line 74 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp19_ = _tmp17_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT];
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp20_ = g_strdup (_ ("%b %-e"));
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (date_xlat_same_year);
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_same_year = _tmp20_;
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp21_ = g_strdup (_ ("%x"));
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (date_xlat_diff_year);
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_diff_year = _tmp21_;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp22_ = g_new0 (gchar*, DATE_CLOCK_FORMAT_TOTAL + 1);
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates = (_vala_array_free (date_xlat_pretty_verbose_dates, date_xlat_pretty_verbose_dates_length1, (GDestroyNotify) g_free), NULL);
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates = _tmp22_;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates_length1 = DATE_CLOCK_FORMAT_TOTAL;
#line 85 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_date_xlat_pretty_verbose_dates_size_ = date_xlat_pretty_verbose_dates_length1;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp23_ = date_xlat_pretty_verbose_dates;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp23__length1 = date_xlat_pretty_verbose_dates_length1;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp24_ = g_strdup (_ ("%B %-e, %Y %-l:%M %P"));
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (_tmp23_[DATE_CLOCK_FORMAT_TWELVE_HOURS]);
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp23_[DATE_CLOCK_FORMAT_TWELVE_HOURS] = _tmp24_;
#line 88 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp25_ = _tmp23_[DATE_CLOCK_FORMAT_TWELVE_HOURS];
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp26_ = date_xlat_pretty_verbose_dates;
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp26__length1 = date_xlat_pretty_verbose_dates_length1;
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp27_ = g_strdup (_ ("%B %-e, %Y %-H:%M"));
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (_tmp26_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS]);
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp26_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS] = _tmp27_;
#line 91 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp28_ = _tmp26_[DATE_CLOCK_FORMAT_TWENTY_FOUR_HOURS];
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp29_ = date_xlat_pretty_verbose_dates;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp29__length1 = date_xlat_pretty_verbose_dates_length1;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp30_ = g_strdup (C_ ("Default full date", "%B %-e, %Y %-l:%M %P"));
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (_tmp29_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT]);
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp29_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT] = _tmp30_;
#line 94 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp31_ = _tmp29_[DATE_CLOCK_FORMAT_LOCALE_DEFAULT];
#line 97 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp32_ = messages_locale;
#line 97 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	if (_tmp32_ != NULL) {
#line 314 "util-date.c"
		const gchar* _tmp33_;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp33_ = messages_locale;
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		setlocale (LC_MESSAGES, _tmp33_);
#line 320 "util-date.c"
	}
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp34_ = language_env;
#line 99 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	if (_tmp34_ != NULL) {
#line 326 "util-date.c"
		const gchar* _tmp35_;
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp35_ = language_env;
#line 100 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		g_setenv ("LANGUAGE", _tmp35_, TRUE);
#line 332 "util-date.c"
	}
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (language_env);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (time_locale);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (messages_locale);
#line 340 "util-date.c"
}


void date_terminate (void) {
	gint _tmp0_;
	gint _tmp1_;
#line 105 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp0_ = date_init_count;
#line 105 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_init_count = _tmp0_ - 1;
#line 105 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp1_ = date_init_count;
#line 105 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	if (_tmp1_ != 0) {
#line 106 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		return;
#line 357 "util-date.c"
	}
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_dates = (_vala_array_free (date_xlat_pretty_dates, date_xlat_pretty_dates_length1, (GDestroyNotify) g_free), NULL);
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_dates = NULL;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_dates_length1 = 0;
#line 108 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_date_xlat_pretty_dates_size_ = date_xlat_pretty_dates_length1;
#line 109 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (date_xlat_same_year);
#line 109 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_same_year = NULL;
#line 110 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (date_xlat_diff_year);
#line 110 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_diff_year = NULL;
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates = (_vala_array_free (date_xlat_pretty_verbose_dates, date_xlat_pretty_verbose_dates_length1, (GDestroyNotify) g_free), NULL);
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates = NULL;
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	date_xlat_pretty_verbose_dates_length1 = 0;
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_date_xlat_pretty_verbose_dates_size_ = date_xlat_pretty_verbose_dates_length1;
#line 383 "util-date.c"
}


gboolean date_same_day (GDateTime* a, GDateTime* b) {
	gboolean result = FALSE;
	gint year1 = 0;
	gint month1 = 0;
	gint day1 = 0;
	GDateTime* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint year2 = 0;
	gint month2 = 0;
	gint day2 = 0;
	GDateTime* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gint _tmp10_;
	gint _tmp11_;
#line 114 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 114 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp0_ = a;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	g_date_time_get_ymd (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	year1 = _tmp1_;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	month1 = _tmp2_;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	day1 = _tmp3_;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp4_ = b;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	g_date_time_get_ymd (_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	year2 = _tmp5_;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	month2 = _tmp6_;
#line 119 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	day2 = _tmp7_;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp10_ = year1;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp11_ = year2;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	if (_tmp10_ == _tmp11_) {
#line 437 "util-date.c"
		gint _tmp12_;
		gint _tmp13_;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp12_ = month1;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp13_ = month2;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp9_ = _tmp12_ == _tmp13_;
#line 446 "util-date.c"
	} else {
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp9_ = FALSE;
#line 450 "util-date.c"
	}
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	if (_tmp9_) {
#line 454 "util-date.c"
		gint _tmp14_;
		gint _tmp15_;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp14_ = day1;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp15_ = day2;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp8_ = _tmp14_ == _tmp15_;
#line 463 "util-date.c"
	} else {
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp8_ = FALSE;
#line 467 "util-date.c"
	}
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	result = _tmp8_;
#line 121 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	return result;
#line 473 "util-date.c"
}


DateCoarseDate date_as_coarse_date (GDateTime* datetime, GDateTime* now, GTimeSpan diff) {
	DateCoarseDate result = 0;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	gboolean _tmp2_;
#line 126 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	g_return_val_if_fail (datetime != NULL, 0);
#line 126 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	g_return_val_if_fail (now != NULL, 0);
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp0_ = datetime;
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp1_ = now;
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp2_ = date_same_day (_tmp0_, _tmp1_);
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	if (_tmp2_) {
#line 494 "util-date.c"
		GTimeSpan _tmp3_;
		GTimeSpan _tmp4_;
		GTimeSpan _tmp5_;
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp3_ = diff;
#line 128 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		if (_tmp3_ < G_TIME_SPAN_MINUTE) {
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_NOW;
#line 129 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 506 "util-date.c"
		}
#line 131 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp4_ = diff;
#line 131 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		if (_tmp4_ < G_TIME_SPAN_HOUR) {
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_MINUTES;
#line 132 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 516 "util-date.c"
		}
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp5_ = diff;
#line 134 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		if (_tmp5_ < (12 * G_TIME_SPAN_HOUR)) {
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_HOURS;
#line 135 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 526 "util-date.c"
		}
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		result = DATE_COARSE_DATE_TODAY;
#line 137 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		return result;
#line 532 "util-date.c"
	} else {
		GDateTime* _tmp6_;
		GDateTime* _tmp7_;
		gint _tmp8_;
		GDateTime* temp = NULL;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
		GDateTime* _tmp12_;
		gboolean _tmp13_;
		GDateTime* _tmp14_;
		GDateTime* _tmp15_;
		gboolean _tmp16_ = FALSE;
		GDateTime* _tmp17_;
		GDateTime* _tmp18_;
		gboolean _tmp19_;
		GDateTime* _tmp23_;
		gint _tmp24_;
		GDateTime* _tmp25_;
		gint _tmp26_;
#line 139 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp6_ = datetime;
#line 139 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp7_ = now;
#line 139 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp8_ = g_date_time_compare (_tmp6_, _tmp7_);
#line 139 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		if (_tmp8_ > 0) {
#line 140 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_FUTURE;
#line 140 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 565 "util-date.c"
		}
#line 143 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp9_ = datetime;
#line 143 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp10_ = g_date_time_add_days (_tmp9_, 1);
#line 143 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_g_date_time_unref0 (temp);
#line 143 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		temp = _tmp10_;
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp11_ = temp;
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp12_ = now;
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp13_ = date_same_day (_tmp11_, _tmp12_);
#line 144 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		if (_tmp13_) {
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_YESTERDAY;
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_date_time_unref0 (temp);
#line 145 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 589 "util-date.c"
		}
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp14_ = datetime;
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp15_ = g_date_time_add_days (_tmp14_, 6);
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_g_date_time_unref0 (temp);
#line 147 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		temp = _tmp15_;
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp17_ = temp;
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp18_ = now;
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp19_ = date_same_day (_tmp17_, _tmp18_);
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		if (_tmp19_) {
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp16_ = TRUE;
#line 609 "util-date.c"
		} else {
			GDateTime* _tmp20_;
			GDateTime* _tmp21_;
			gint _tmp22_;
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp20_ = temp;
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp21_ = now;
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp22_ = g_date_time_compare (_tmp20_, _tmp21_);
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp16_ = _tmp22_ >= 0;
#line 622 "util-date.c"
		}
#line 148 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		if (_tmp16_) {
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_THIS_WEEK;
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_date_time_unref0 (temp);
#line 149 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 632 "util-date.c"
		}
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp23_ = datetime;
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp24_ = g_date_time_get_year (_tmp23_);
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp25_ = now;
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_tmp26_ = g_date_time_get_year (_tmp25_);
#line 151 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		if (_tmp24_ == _tmp26_) {
#line 152 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_THIS_YEAR;
#line 152 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_date_time_unref0 (temp);
#line 152 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 650 "util-date.c"
		} else {
#line 154 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = DATE_COARSE_DATE_YEARS;
#line 154 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_date_time_unref0 (temp);
#line 154 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 658 "util-date.c"
		}
#line 127 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		_g_date_time_unref0 (temp);
#line 662 "util-date.c"
	}
}


gchar* date_pretty_print_coarse (DateCoarseDate coarse_date, DateClockFormat clock_format, GDateTime* datetime, GTimeSpan diff) {
	gchar* result = NULL;
	gchar* fmt = NULL;
	DateCoarseDate _tmp0_;
	GDateTime* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
#line 160 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp0_ = coarse_date;
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	switch (_tmp0_) {
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		case DATE_COARSE_DATE_NOW:
#line 682 "util-date.c"
		{
			gchar* _tmp1_;
#line 164 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp1_ = g_strdup (_ ("Now"));
#line 164 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = _tmp1_;
#line 164 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 164 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 693 "util-date.c"
		}
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		case DATE_COARSE_DATE_MINUTES:
#line 697 "util-date.c"
		{
			GTimeSpan _tmp2_;
			GTimeSpan _tmp3_;
			gchar* _tmp4_;
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp2_ = diff;
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp3_ = diff;
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp4_ = g_strdup_printf (ngettext ("%dm ago", "%dm ago", (gulong) (_tmp2_ / G_TIME_SPAN_MINUTE)), (gint) (_tmp3_ / G_TIME_SPAN_MINUTE));
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = _tmp4_;
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 167 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 714 "util-date.c"
		}
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		case DATE_COARSE_DATE_HOURS:
#line 718 "util-date.c"
		{
			gint rounded = 0;
			GTimeSpan _tmp5_;
			gdouble _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gchar* _tmp9_;
#line 170 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp5_ = diff;
#line 170 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp6_ = round (((gdouble) _tmp5_) / G_TIME_SPAN_HOUR);
#line 170 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			rounded = (gint) _tmp6_;
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp7_ = rounded;
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp8_ = rounded;
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp9_ = g_strdup_printf (ngettext ("%dh ago", "%dh ago", (gulong) _tmp7_), _tmp8_);
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = _tmp9_;
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 171 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 744 "util-date.c"
		}
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		case DATE_COARSE_DATE_TODAY:
#line 748 "util-date.c"
		{
			gchar** _tmp10_;
			gint _tmp10__length1;
			DateClockFormat _tmp11_;
			gint _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
#line 174 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp10_ = date_xlat_pretty_dates;
#line 174 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp10__length1 = date_xlat_pretty_dates_length1;
#line 174 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp11_ = clock_format;
#line 174 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp12_ = date_clock_format_to_index (_tmp11_);
#line 174 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp13_ = _tmp10_[_tmp12_];
#line 174 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 174 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 174 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			fmt = _tmp14_;
#line 175 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			break;
#line 774 "util-date.c"
		}
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		case DATE_COARSE_DATE_YESTERDAY:
#line 778 "util-date.c"
		{
			gchar* _tmp15_;
#line 178 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp15_ = g_strdup (_ ("Yesterday"));
#line 178 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			result = _tmp15_;
#line 178 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 178 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			return result;
#line 789 "util-date.c"
		}
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		case DATE_COARSE_DATE_THIS_WEEK:
#line 793 "util-date.c"
		{
			gchar* _tmp16_;
#line 183 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp16_ = g_strdup (_ ("%A"));
#line 183 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 183 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			fmt = _tmp16_;
#line 184 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			break;
#line 804 "util-date.c"
		}
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		case DATE_COARSE_DATE_THIS_YEAR:
#line 808 "util-date.c"
		{
			const gchar* _tmp17_;
			gchar* _tmp18_;
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp17_ = date_xlat_same_year;
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp18_ = g_strdup (_tmp17_);
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 187 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			fmt = _tmp18_;
#line 188 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			break;
#line 822 "util-date.c"
		}
		default:
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		case DATE_COARSE_DATE_YEARS:
#line 162 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
		case DATE_COARSE_DATE_FUTURE:
#line 829 "util-date.c"
		{
			const gchar* _tmp19_;
			gchar* _tmp20_;
#line 193 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp19_ = date_xlat_diff_year;
#line 193 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 193 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			_g_free0 (fmt);
#line 193 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			fmt = _tmp20_;
#line 194 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
			break;
#line 843 "util-date.c"
		}
	}
#line 197 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp21_ = datetime;
#line 197 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp22_ = fmt;
#line 197 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp23_ = g_date_time_format (_tmp21_, _tmp22_);
#line 197 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	result = _tmp23_;
#line 197 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_free0 (fmt);
#line 197 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	return result;
#line 858 "util-date.c"
}


gchar* date_pretty_print (GDateTime* datetime, DateClockFormat clock_format) {
	gchar* result = NULL;
	GDateTime* to_local = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* now = NULL;
	GDateTime* _tmp2_;
	GTimeSpan diff = 0LL;
	GTimeSpan _tmp3_;
	DateCoarseDate _tmp4_;
	DateClockFormat _tmp5_;
	gchar* _tmp6_;
#line 200 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 201 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp0_ = datetime;
#line 201 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp1_ = g_date_time_to_local (_tmp0_);
#line 201 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	to_local = _tmp1_;
#line 202 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 202 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	now = _tmp2_;
#line 203 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp3_ = g_date_time_difference (now, to_local);
#line 203 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	diff = _tmp3_;
#line 205 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp4_ = date_as_coarse_date (to_local, now, diff);
#line 205 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp5_ = clock_format;
#line 205 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp6_ = date_pretty_print_coarse (_tmp4_, _tmp5_, to_local, diff);
#line 205 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	result = _tmp6_;
#line 205 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_date_time_unref0 (now);
#line 205 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_g_date_time_unref0 (to_local);
#line 205 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	return result;
#line 904 "util-date.c"
}


gchar* date_pretty_print_verbose (GDateTime* datetime, DateClockFormat clock_format) {
	gchar* result = NULL;
	GDateTime* _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	DateClockFormat _tmp2_;
	gint _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 208 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	g_return_val_if_fail (datetime != NULL, NULL);
#line 209 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp0_ = datetime;
#line 209 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp1_ = date_xlat_pretty_verbose_dates;
#line 209 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp1__length1 = date_xlat_pretty_verbose_dates_length1;
#line 209 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp2_ = clock_format;
#line 209 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp3_ = date_clock_format_to_index (_tmp2_);
#line 209 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp4_ = _tmp1_[_tmp3_];
#line 209 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	_tmp5_ = g_date_time_format (_tmp0_, _tmp4_);
#line 209 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	result = _tmp5_;
#line 209 "/builddir/build/BUILD/geary-0.12.2/src/client/util/util-date.vala"
	return result;
#line 937 "util-date.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 944 "util-date.c"
		int i;
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
				destroy_func (((gpointer*) array)[i]);
#line 952 "util-date.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 8 "/builddir/build/BUILD/geary-0.12.2/src/client/notification/libnotify.vala"
	g_free (array);
#line 964 "util-date.c"
}



