/* util-inet.c generated by valac 0.36.12, the Vala compiler
 * generated from util-inet.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



#define GEARY_INET_HOST_PART_REGEX "^(?!-)[\\p{L}\\p{N}-]{1,63}(?<!-)$"
#define GEARY_INET_IPv6_REGEX "^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\\.){3}([0-9]|[1-9][" \
"0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$|^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\\-" \
"]*[a-zA-Z0-9])\\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\\-]*[A-Za-z0-9])$|^\\s" \
"*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}" \
"(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|" \
"2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A" \
"-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]" \
"|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9" \
"A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\\d|1\\d\\d|" \
"[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-" \
"Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:(" \
"(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1" \
"-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|" \
"((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(2" \
"5[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(" \
"((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\\" \
"d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3}))|:)" \
")|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[" \
"0-4]\\d|1\\d\\d|[1-9]?\\d)(\\.(25[0-5]|2[0-4]\\d|1\\d\\d|[1-9]?\\d)){3" \
"}))|:)))(%.+)?\\s*$"
gchar* geary_inet_address_to_string (GInetSocketAddress* addr);
gboolean geary_inet_is_valid_display_host (gchar* name);
gboolean geary_string_is_empty (const gchar* str);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Formats a socket address as a "name:port" string.
 */
gchar* geary_inet_address_to_string (GInetSocketAddress* addr) {
	gchar* result = NULL;
	GInetSocketAddress* _tmp0_;
	GInetAddress* _tmp1_;
	GInetAddress* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GInetSocketAddress* _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
#line 15 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	g_return_val_if_fail (G_IS_INET_SOCKET_ADDRESS (addr), NULL);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp0_ = addr;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp1_ = g_inet_socket_address_get_address (_tmp0_);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp2_ = _tmp1_;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp3_ = g_inet_address_to_string (_tmp2_);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp4_ = _tmp3_;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp5_ = addr;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp6_ = g_inet_socket_address_get_port (_tmp5_);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp7_ = _tmp6_;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp8_ = g_strdup_printf ("%s:%u", _tmp4_, _tmp7_);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp9_ = _tmp8_;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_g_free0 (_tmp4_);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	result = _tmp9_;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	return result;
#line 76 "util-inet.c"
}


/**
 * Determines if a string represents a valid host name or IP address.
 *
 * This function validates a host name or IP address for display,
 * i.e. without IDN or URI encoding. It simply performs a syntactic
 * check, it does not attempt to resolve the host name. Note that both
 * valid IPv4 addresses (such as "123.0.10.100") and invalid IPv4
 * addresses (such as "123" or "555.123.456.789") are valid host
 * names, so it is not possible to determine if an IPv4 address is
 * invalid.
 */
static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
#line 1110 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1111 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1111 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1111 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1111 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 105 "util-inet.c"
}


static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	glong _tmp2_;
	glong _tmp5_;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_;
	glong _tmp16_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	gchar* _tmp21_;
#line 1355 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1356 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1356 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1356 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1357 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp2_ = start;
#line 1357 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp2_ < ((glong) 0)) {
#line 138 "util-inet.c"
		glong _tmp3_;
		glong _tmp4_;
#line 1358 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1358 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp4_ = start;
#line 1358 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		start = _tmp3_ + _tmp4_;
#line 147 "util-inet.c"
	}
#line 1360 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp5_ = end;
#line 1360 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp5_ < ((glong) 0)) {
#line 153 "util-inet.c"
		glong _tmp6_;
		glong _tmp7_;
#line 1361 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp6_ = string_length;
#line 1361 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp7_ = end;
#line 1361 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		end = _tmp6_ + _tmp7_;
#line 162 "util-inet.c"
	}
#line 1363 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp9_ = start;
#line 1363 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp9_ >= ((glong) 0)) {
#line 168 "util-inet.c"
		glong _tmp10_;
		glong _tmp11_;
#line 1363 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp10_ = start;
#line 1363 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp11_ = string_length;
#line 1363 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp10_ <= _tmp11_;
#line 177 "util-inet.c"
	} else {
#line 1363 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp8_ = FALSE;
#line 181 "util-inet.c"
	}
#line 1363 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp8_, NULL);
#line 1364 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp13_ = end;
#line 1364 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	if (_tmp13_ >= ((glong) 0)) {
#line 189 "util-inet.c"
		glong _tmp14_;
		glong _tmp15_;
#line 1364 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp14_ = end;
#line 1364 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1364 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp12_ = _tmp14_ <= _tmp15_;
#line 198 "util-inet.c"
	} else {
#line 1364 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
		_tmp12_ = FALSE;
#line 202 "util-inet.c"
	}
#line 1364 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp12_, NULL);
#line 1365 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp16_ = start;
#line 1365 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp17_ = end;
#line 1365 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
#line 1366 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp18_ = start;
#line 1366 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp19_ = end;
#line 1366 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp20_ = start;
#line 1366 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
#line 1366 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	result = _tmp21_;
#line 1366 "/usr/share/vala-0.36/vapi/glib-2.0.vapi"
	return result;
#line 224 "util-inet.c"
}


gboolean geary_inet_is_valid_display_host (gchar* name) {
	gboolean result = FALSE;
	gboolean is_valid = FALSE;
	const gchar* _tmp0_;
	gboolean _tmp1_;
	GError * _inner_error_ = NULL;
#line 31 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	is_valid = FALSE;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp0_ = name;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_tmp1_ = geary_string_is_empty (_tmp0_);
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	if (!_tmp1_) {
#line 242 "util-inet.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gboolean _tmp23_;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
		_tmp2_ = name;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
		_tmp3_ = strlen (_tmp2_);
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
		_tmp4_ = _tmp3_;
#line 35 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
		if (_tmp4_ <= 253) {
#line 255 "util-inet.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gchar _tmp9_;
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
			_tmp5_ = name;
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
			_tmp6_ = name;
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
			_tmp7_ = strlen (_tmp6_);
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
			_tmp8_ = _tmp7_;
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
			_tmp9_ = string_get (_tmp5_, (glong) (_tmp8_ - 1));
#line 36 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
			if (_tmp9_ == '.') {
#line 273 "util-inet.c"
				const gchar* _tmp10_;
				gchar* _tmp11_;
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp10_ = name;
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp11_ = string_slice (_tmp10_, (glong) 0, (glong) -1);
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_g_free0 (name);
#line 37 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				name = _tmp11_;
#line 284 "util-inet.c"
			}
			{
				GRegex* part_regex = NULL;
				GRegex* _tmp12_;
				const gchar* _tmp13_;
				gchar** _tmp14_;
				gchar** _tmp15_;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp12_ = g_regex_new (GEARY_INET_HOST_PART_REGEX, 0, 0, &_inner_error_);
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				part_regex = _tmp12_;
#line 39 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 298 "util-inet.c"
					goto __catch317_g_error;
				}
#line 40 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				is_valid = TRUE;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp13_ = name;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, ".", 0);
#line 307 "util-inet.c"
				{
					gchar** part_collection = NULL;
					gint part_collection_length1 = 0;
					gint _part_collection_size_ = 0;
					gint part_it = 0;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
					part_collection = _tmp15_;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
					part_collection_length1 = _vala_array_length (_tmp14_);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
					for (part_it = 0; part_it < _vala_array_length (_tmp14_); part_it = part_it + 1) {
#line 319 "util-inet.c"
						gchar* _tmp16_;
						gchar* part = NULL;
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
						_tmp16_ = g_strdup (part_collection[part_it]);
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
						part = _tmp16_;
#line 326 "util-inet.c"
						{
							GRegex* _tmp17_;
							const gchar* _tmp18_;
							gboolean _tmp19_;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
							_tmp17_ = part_regex;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
							_tmp18_ = part;
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
							_tmp19_ = g_regex_match (_tmp17_, _tmp18_, 0, NULL);
#line 42 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
							if (!_tmp19_) {
#line 43 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
								is_valid = FALSE;
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
								_g_free0 (part);
#line 44 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
								break;
#line 345 "util-inet.c"
							}
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
							_g_free0 (part);
#line 349 "util-inet.c"
						}
					}
#line 41 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
					part_collection = (_vala_array_free (part_collection, part_collection_length1, (GDestroyNotify) g_free), NULL);
#line 354 "util-inet.c"
				}
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_g_regex_unref0 (part_regex);
#line 358 "util-inet.c"
			}
			goto __finally317;
			__catch317_g_error:
			{
				GError* err = NULL;
				GError* _tmp20_;
				const gchar* _tmp21_;
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				err = _inner_error_;
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_inner_error_ = NULL;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp20_ = err;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp21_ = _tmp20_->message;
#line 48 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				g_debug ("util-inet.vala:48: Error validating as host name: %s", _tmp21_);
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_g_error_free0 (err);
#line 378 "util-inet.c"
			}
			__finally317:
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 383 "util-inet.c"
				gboolean _tmp22_ = FALSE;
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_g_free0 (name);
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				g_clear_error (&_inner_error_);
#line 38 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				return _tmp22_;
#line 393 "util-inet.c"
			}
		}
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
		_tmp23_ = is_valid;
#line 53 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
		if (!_tmp23_) {
#line 400 "util-inet.c"
			{
				GRegex* address_regex = NULL;
				GRegex* _tmp24_;
				GRegex* _tmp25_;
				const gchar* _tmp26_;
				gboolean _tmp27_;
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp24_ = g_regex_new (GEARY_INET_IPv6_REGEX, G_REGEX_CASELESS, 0, &_inner_error_);
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				address_regex = _tmp24_;
#line 55 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 413 "util-inet.c"
					goto __catch318_g_error;
				}
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp25_ = address_regex;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp26_ = name;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp27_ = g_regex_match (_tmp25_, _tmp26_, 0, NULL);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				is_valid = _tmp27_;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_g_regex_unref0 (address_regex);
#line 426 "util-inet.c"
			}
			goto __finally318;
			__catch318_g_error:
			{
				GError* err = NULL;
				GError* _tmp28_;
				const gchar* _tmp29_;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				err = _inner_error_;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_inner_error_ = NULL;
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp28_ = err;
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_tmp29_ = _tmp28_->message;
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				g_debug ("util-inet.vala:60: Error validating as IPv6 address: %s", _tmp29_);
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_g_error_free0 (err);
#line 446 "util-inet.c"
			}
			__finally318:
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 451 "util-inet.c"
				gboolean _tmp30_ = FALSE;
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				_g_free0 (name);
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				g_clear_error (&_inner_error_);
#line 54 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
				return _tmp30_;
#line 461 "util-inet.c"
			}
		}
	}
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	result = is_valid;
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	_g_free0 (name);
#line 64 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-inet.vala"
	return result;
#line 471 "util-inet.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



