/* util-synchronization.c generated by valac 0.36.12, the Vala compiler
 * generated from util-synchronization.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <string.h>


#define GEARY_TYPE_BASE_INTERFACE (geary_base_interface_get_type ())
#define GEARY_BASE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface))
#define GEARY_IS_BASE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_INTERFACE))
#define GEARY_BASE_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GEARY_TYPE_BASE_INTERFACE, GearyBaseInterfaceIface))

typedef struct _GearyBaseInterface GearyBaseInterface;
typedef struct _GearyBaseInterfaceIface GearyBaseInterfaceIface;

#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;
typedef struct _GearyBaseObjectPrivate GearyBaseObjectPrivate;

#define GEARY_SYNCHRONIZATION_TYPE_SPIN_WAITER (geary_synchronization_spin_waiter_get_type ())
#define GEARY_SYNCHRONIZATION_SPIN_WAITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_SYNCHRONIZATION_TYPE_SPIN_WAITER, GearySynchronizationSpinWaiter))
#define GEARY_SYNCHRONIZATION_SPIN_WAITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_SYNCHRONIZATION_TYPE_SPIN_WAITER, GearySynchronizationSpinWaiterClass))
#define GEARY_SYNCHRONIZATION_IS_SPIN_WAITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_SYNCHRONIZATION_TYPE_SPIN_WAITER))
#define GEARY_SYNCHRONIZATION_IS_SPIN_WAITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_SYNCHRONIZATION_TYPE_SPIN_WAITER))
#define GEARY_SYNCHRONIZATION_SPIN_WAITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_SYNCHRONIZATION_TYPE_SPIN_WAITER, GearySynchronizationSpinWaiterClass))

typedef struct _GearySynchronizationSpinWaiter GearySynchronizationSpinWaiter;
typedef struct _GearySynchronizationSpinWaiterClass GearySynchronizationSpinWaiterClass;
typedef struct _GearySynchronizationSpinWaiterPrivate GearySynchronizationSpinWaiterPrivate;

struct _GearyBaseInterfaceIface {
	GTypeInterface parent_iface;
};

struct _GearyBaseObject {
	GObject parent_instance;
	GearyBaseObjectPrivate * priv;
};

struct _GearyBaseObjectClass {
	GObjectClass parent_class;
};

struct _GearySynchronizationSpinWaiter {
	GearyBaseObject parent_instance;
	GearySynchronizationSpinWaiterPrivate * priv;
};

struct _GearySynchronizationSpinWaiterClass {
	GearyBaseObjectClass parent_class;
};

typedef gboolean (*GearySynchronizationSpinWaiterPollService) (void* user_data);
struct _GearySynchronizationSpinWaiterPrivate {
	gint poll_msec;
	GearySynchronizationSpinWaiterPollService cb;
	gpointer cb_target;
	GDestroyNotify cb_target_destroy_notify;
	GMutex mutex;
	GCond cond;
	gboolean notified;
};


static gpointer geary_synchronization_spin_waiter_parent_class = NULL;

GType geary_base_interface_get_type (void) G_GNUC_CONST;
GType geary_base_object_get_type (void) G_GNUC_CONST;
GType geary_synchronization_spin_waiter_get_type (void) G_GNUC_CONST;
#define GEARY_SYNCHRONIZATION_SPIN_WAITER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEARY_SYNCHRONIZATION_TYPE_SPIN_WAITER, GearySynchronizationSpinWaiterPrivate))
enum  {
	GEARY_SYNCHRONIZATION_SPIN_WAITER_0_PROPERTY
};
GearySynchronizationSpinWaiter* geary_synchronization_spin_waiter_new (gint poll_msec, GearySynchronizationSpinWaiterPollService cb, void* cb_target);
GearySynchronizationSpinWaiter* geary_synchronization_spin_waiter_construct (GType object_type, gint poll_msec, GearySynchronizationSpinWaiterPollService cb, void* cb_target);
GearyBaseObject* geary_base_object_construct (GType object_type);
gboolean geary_synchronization_spin_waiter_wait (GearySynchronizationSpinWaiter* self, GCancellable* cancellable, GError** error);
gint64 geary_numeric_int64_floor (gint64 value, gint64 floor);
void geary_synchronization_spin_waiter_notify (GearySynchronizationSpinWaiter* self);
gboolean geary_synchronization_spin_waiter_is_notified (GearySynchronizationSpinWaiter* self);
static void geary_synchronization_spin_waiter_finalize (GObject * obj);
static void _vala_clear_GMutex (GMutex * mutex);
static void _vala_clear_GRecMutex (GRecMutex * mutex);
static void _vala_clear_GRWLock (GRWLock * mutex);
static void _vala_clear_GCond (GCond * mutex);


/**
     * Create a {@link SpinWaiter}.
     *
     * poll_msec indicates how long to delay while spinning before interrupting and allowing
     * the {@link PollService} to execute.  If poll_msec is zero or less, PollService will be
     * called constantly.
     */
GearySynchronizationSpinWaiter* geary_synchronization_spin_waiter_construct (GType object_type, gint poll_msec, GearySynchronizationSpinWaiterPollService cb, void* cb_target) {
	GearySynchronizationSpinWaiter * self = NULL;
	gint _tmp0_;
	GearySynchronizationSpinWaiterPollService _tmp1_;
	void* _tmp1__target;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self = (GearySynchronizationSpinWaiter*) geary_base_object_construct (object_type);
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_tmp0_ = poll_msec;
#line 33 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->poll_msec = _tmp0_;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_tmp1_ = cb;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_tmp1__target = cb_target;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	(self->priv->cb_target_destroy_notify == NULL) ? NULL : (self->priv->cb_target_destroy_notify (self->priv->cb_target), NULL);
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->cb = NULL;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->cb_target = NULL;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->cb_target_destroy_notify = NULL;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->cb = _tmp1_;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->cb_target = _tmp1__target;
#line 34 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->cb_target_destroy_notify = NULL;
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	return self;
#line 142 "util-synchronization.c"
}


GearySynchronizationSpinWaiter* geary_synchronization_spin_waiter_new (gint poll_msec, GearySynchronizationSpinWaiterPollService cb, void* cb_target) {
#line 32 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	return geary_synchronization_spin_waiter_construct (GEARY_SYNCHRONIZATION_TYPE_SPIN_WAITER, poll_msec, cb, cb_target);
#line 149 "util-synchronization.c"
}


/**
     * Spins waiting for a completion state to be reached.
     *
     * There's two ways the completion state can be reached: (1) PollService returns false,
     * indicating an abort state, (2) {@link notify} is called, indicating a success state, or
     * (3) the Cancellable was cancelled, causing an IOError.CANCELLED exception to be thrown.
     *
     * {@link PollService} will be called from within the calling thread context.
     *
     * Although this is thread-safe, it's not designed to be invoked by multiple callers.  That
     * could cause the PollService callback to be called more often than specified in the
     * constructor.
     */
gboolean geary_synchronization_spin_waiter_wait (GearySynchronizationSpinWaiter* self, GCancellable* cancellable, GError** error) {
	gboolean result = FALSE;
	gint64 actual_poll_msec = 0LL;
	gint _tmp0_;
	gint64 _tmp1_;
	gboolean _result_ = FALSE;
	gboolean _tmp13_;
	GCancellable* _tmp14_;
	gboolean _tmp15_;
	GError * _inner_error_ = NULL;
#line 50 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_return_val_if_fail (GEARY_SYNCHRONIZATION_IS_SPIN_WAITER (self), FALSE);
#line 50 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), FALSE);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_tmp0_ = self->priv->poll_msec;
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_tmp1_ = geary_numeric_int64_floor ((gint64) 0, (gint64) _tmp0_);
#line 52 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	actual_poll_msec = _tmp1_;
#line 56 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_mutex_lock (&self->priv->mutex);
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	while (TRUE) {
#line 190 "util-synchronization.c"
		gboolean _tmp2_;
		gboolean _tmp3_ = FALSE;
		GCancellable* _tmp4_;
		gint64 end_time = 0LL;
		gint64 _tmp7_;
		gint64 _tmp8_;
		gint64 _tmp9_;
		gboolean _tmp10_;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		_tmp2_ = self->priv->notified;
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		if (!(!_tmp2_)) {
#line 58 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			break;
#line 205 "util-synchronization.c"
		}
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		_tmp4_ = cancellable;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		if (_tmp4_ != NULL) {
#line 211 "util-synchronization.c"
			GCancellable* _tmp5_;
			gboolean _tmp6_;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			_tmp5_ = cancellable;
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			_tmp6_ = g_cancellable_is_cancelled (_tmp5_);
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			_tmp3_ = _tmp6_;
#line 220 "util-synchronization.c"
		} else {
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			_tmp3_ = FALSE;
#line 224 "util-synchronization.c"
		}
#line 59 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		if (_tmp3_) {
#line 60 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			break;
#line 230 "util-synchronization.c"
		}
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		_tmp7_ = g_get_monotonic_time ();
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		_tmp8_ = actual_poll_msec;
#line 62 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		end_time = _tmp7_ + (_tmp8_ * G_TIME_SPAN_MILLISECOND);
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		_tmp9_ = end_time;
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		_tmp10_ = g_cond_wait_until (&self->priv->cond, &self->priv->mutex, _tmp9_);
#line 63 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		if (!_tmp10_) {
#line 244 "util-synchronization.c"
			GearySynchronizationSpinWaiterPollService _tmp11_;
			void* _tmp11__target;
			gboolean _tmp12_;
#line 65 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			g_mutex_unlock (&self->priv->mutex);
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			_tmp11_ = self->priv->cb;
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			_tmp11__target = self->priv->cb_target;
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			_tmp12_ = _tmp11_ (_tmp11__target);
#line 66 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			if (!_tmp12_) {
#line 68 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
				g_mutex_lock (&self->priv->mutex);
#line 70 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
				break;
#line 262 "util-synchronization.c"
			}
#line 72 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
			g_mutex_lock (&self->priv->mutex);
#line 266 "util-synchronization.c"
		}
	}
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_tmp13_ = self->priv->notified;
#line 76 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_result_ = _tmp13_;
#line 78 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_tmp14_ = cancellable;
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_tmp15_ = g_cancellable_is_cancelled (_tmp14_);
#line 80 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	if (_tmp15_) {
#line 281 "util-synchronization.c"
		GError* _tmp16_;
		gboolean _tmp17_ = FALSE;
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		_tmp16_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_CANCELLED, "SpinWaiter.wait cancelled");
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		_inner_error_ = _tmp16_;
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		g_propagate_error (error, _inner_error_);
#line 81 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
		return _tmp17_;
#line 292 "util-synchronization.c"
	}
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	result = _result_;
#line 83 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	return result;
#line 298 "util-synchronization.c"
}


/**
     * Signals a completion state to a thread calling {@link wait}.
     *
     * This call is thread-safe.  However, once a {@link SpinWaiter} has been signalled to stop,
     * it cannot be restarted.
     */
void geary_synchronization_spin_waiter_notify (GearySynchronizationSpinWaiter* self) {
#line 92 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_return_if_fail (GEARY_SYNCHRONIZATION_IS_SPIN_WAITER (self));
#line 93 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_mutex_lock (&self->priv->mutex);
#line 95 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->notified = TRUE;
#line 96 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_cond_broadcast (&self->priv->cond);
#line 98 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 319 "util-synchronization.c"
}


/**
     * Indicates if the {@link SpinWaiter} has been notified.
     *
     * Other completion states (PollService returning false, Cancellable being cancelled in
     * {@link wait}) are not recorded here.
     *
     * This method is thread-safe.
     *
     * @see notify
     */
gboolean geary_synchronization_spin_waiter_is_notified (GearySynchronizationSpinWaiter* self) {
	gboolean result = FALSE;
	gboolean _result_ = FALSE;
	gboolean _tmp0_;
#line 111 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_return_val_if_fail (GEARY_SYNCHRONIZATION_IS_SPIN_WAITER (self), FALSE);
#line 114 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_mutex_lock (&self->priv->mutex);
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_tmp0_ = self->priv->notified;
#line 116 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_result_ = _tmp0_;
#line 118 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_mutex_unlock (&self->priv->mutex);
#line 120 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	result = _result_;
#line 120 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	return result;
#line 351 "util-synchronization.c"
}


static void geary_synchronization_spin_waiter_class_init (GearySynchronizationSpinWaiterClass * klass) {
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	geary_synchronization_spin_waiter_parent_class = g_type_class_peek_parent (klass);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_type_class_add_private (klass, sizeof (GearySynchronizationSpinWaiterPrivate));
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_synchronization_spin_waiter_finalize;
#line 362 "util-synchronization.c"
}


static void geary_synchronization_spin_waiter_instance_init (GearySynchronizationSpinWaiter * self) {
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv = GEARY_SYNCHRONIZATION_SPIN_WAITER_GET_PRIVATE (self);
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_mutex_init (&self->priv->mutex);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	g_cond_init (&self->priv->cond);
#line 23 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->notified = FALSE;
#line 375 "util-synchronization.c"
}


static void geary_synchronization_spin_waiter_finalize (GObject * obj) {
	GearySynchronizationSpinWaiter * self;
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_SYNCHRONIZATION_TYPE_SPIN_WAITER, GearySynchronizationSpinWaiter);
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	(self->priv->cb_target_destroy_notify == NULL) ? NULL : (self->priv->cb_target_destroy_notify (self->priv->cb_target), NULL);
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->cb = NULL;
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->cb_target = NULL;
#line 20 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	self->priv->cb_target_destroy_notify = NULL;
#line 21 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_vala_clear_GMutex (&self->priv->mutex);
#line 22 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	_vala_clear_GCond (&self->priv->cond);
#line 16 "/builddir/build/BUILD/geary-0.12.2/src/engine/util/util-synchronization.vala"
	G_OBJECT_CLASS (geary_synchronization_spin_waiter_parent_class)->finalize (obj);
#line 397 "util-synchronization.c"
}


/**
 * A synchronization primitive that spins waiting for a completion state to be reached.
 *
 * SpinWaiter allows for the caller to specify work to be performed periodically in a callback
 * while waiting for another thread to notify completion.
 */
GType geary_synchronization_spin_waiter_get_type (void) {
	static volatile gsize geary_synchronization_spin_waiter_type_id__volatile = 0;
	if (g_once_init_enter (&geary_synchronization_spin_waiter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearySynchronizationSpinWaiterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_synchronization_spin_waiter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearySynchronizationSpinWaiter), 0, (GInstanceInitFunc) geary_synchronization_spin_waiter_instance_init, NULL };
		GType geary_synchronization_spin_waiter_type_id;
		geary_synchronization_spin_waiter_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearySynchronizationSpinWaiter", &g_define_type_info, 0);
		g_once_init_leave (&geary_synchronization_spin_waiter_type_id__volatile, geary_synchronization_spin_waiter_type_id);
	}
	return geary_synchronization_spin_waiter_type_id__volatile;
}


static void _vala_clear_GMutex (GMutex * mutex) {
	GMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GMutex))) {
		g_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GMutex));
	}
}


static void _vala_clear_GRecMutex (GRecMutex * mutex) {
	GRecMutex zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRecMutex))) {
		g_rec_mutex_clear (mutex);
		memset (mutex, 0, sizeof (GRecMutex));
	}
}


static void _vala_clear_GRWLock (GRWLock * mutex) {
	GRWLock zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GRWLock))) {
		g_rw_lock_clear (mutex);
		memset (mutex, 0, sizeof (GRWLock));
	}
}


static void _vala_clear_GCond (GCond * mutex) {
	GCond zero_mutex = { 0 };
	if (memcmp (mutex, &zero_mutex, sizeof (GCond))) {
		g_cond_clear (mutex);
		memset (mutex, 0, sizeof (GCond));
	}
}



